/* game_?.data erstellen
** gcc -Wall make_gamedata.c -o make_gamedata
*/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <vgagames.h>
#include "mrsnake.h"

/* Ebene setzen
**  - EB_EN_MAX=99:   max. Anzahl Feindschlangen pro Ebene
** Struktur-Elemente:
**  - int hell:  Helligkeit (-63/62)
**  - int freib:  Hoehlenbodennummer (Grafik "freib?.vga")
**  - int mauer:  Hoehlenmauernummer (Grafik "mauer?.vga")
**  - int musnr:  Musiknummer (m?.mid)
**  - int en_anz:  Mindestanzahl Feindschlangen gleichzeitig aktiv
**  - int en_max:  Gesamtanzahl Feindschlangen
**  - int gattung[EB_EN_MAX]:  Gattung jeder Feindschlange (0 bis 6)
**  - int warte_max[EB_EN_MAX]:  Rundenanzahl bevor naechste Schlange kommt
**  - int giftfl_weg:  Giftflasche: wie viele Runden inaktiv
**  - int giftfl_da:  Giftflasche: wie viele Runden aktiv
**  - int giftfl_max:  Giftflasche: Maximalanzahl Aktivierung
**  - int tarnkp_weg:  Tarnkappe: wie viele Runden inaktiv
**  - int tarnkp_da:  Tarnkappe: wie viele Runden aktiv
**  - int tarnkp_max: Tarnkappe: Maximalanzahl Aktivierung
*/

ebene ebn[10];
int ebz;

int main(int argc,char ** argv) {
  int i1,i2;
  srand(time(NULL)%1000);
  memset(ebn,0,sizeof(ebn));

  if (argc<2) {
    fprintf(stderr,"Usage: %s <1|2>\n",argv[0]);
    fprintf(stderr,"Creates game.data file to stdout\n");
    return(1);
  }

  if (atoi(argv[1])==1) {  /* leicht */
    /* 1.Runde */
    ebz=0;
    ebn[ebz].hell=0;
    ebn[ebz].freib=ebn[ebz].mauer=1;
    ebn[ebz].musnr=1;
    ebn[ebz].en_anz=3;
    ebn[ebz].en_max=18;
    for (i1=0;i1<ebn[ebz].en_max;i1++) {  /* 0 */
      ebn[ebz].gattung[i1]=0;
      ebn[ebz].warte_max[i1]=900+ZUFALL(100)-50;
    }
    ebn[ebz].gattung[ebn[ebz].en_max-5]=1;
    ebn[ebz].gattung[ebn[ebz].en_max-2]=1;
    ebn[ebz].giftfl_weg=1200;
    ebn[ebz].giftfl_da=800;
    ebn[ebz].giftfl_max=5;
    ebn[ebz].tarnkp_weg=2000;
    ebn[ebz].tarnkp_da=800;
    ebn[ebz].tarnkp_max=2;
  
    /* 2.Runde */
    ebz++;
    ebn[ebz].hell=-15;
    ebn[ebz].freib=ebn[ebz].mauer=1;
    ebn[ebz].musnr=1;
    ebn[ebz].en_anz=5;
    ebn[ebz].en_max=30;
    for (i1=0;i1<ebn[ebz].en_max;i1++) {  /* 0(,1,2) */
      if ((i2=ZUFALL(7)/5)>=1) {i2=1+ZUFALL(10)/5;}
      ebn[ebz].gattung[i1]=i2;
      ebn[ebz].warte_max[i1]=1200+ZUFALL(160)-80;
    }
    ebn[ebz].giftfl_weg=1100;
    ebn[ebz].giftfl_da=800;
    ebn[ebz].giftfl_max=6;
    ebn[ebz].tarnkp_weg=2000;
    ebn[ebz].tarnkp_da=800;
    ebn[ebz].tarnkp_max=2;
  
    /* 3.Runde */
    ebz++;
    ebn[ebz].hell=0;
    ebn[ebz].freib=ebn[ebz].mauer=2;
    ebn[ebz].musnr=2;
    ebn[ebz].en_anz=4;
    ebn[ebz].en_max=25;
    for (i1=0;i1<ebn[ebz].en_max;i1++) {  /* (0,)1,2 */
      if ((i2=ZUFALL(7)/3)>=1) {i2=1+ZUFALL(10)/5;}
      ebn[ebz].gattung[i1]=i2;
      ebn[ebz].warte_max[i1]=1200+ZUFALL(180)-90;
    }
    ebn[ebz].giftfl_weg=1000;
    ebn[ebz].giftfl_da=800;
    ebn[ebz].giftfl_max=7;
    ebn[ebz].tarnkp_weg=2500;
    ebn[ebz].tarnkp_da=800;
    ebn[ebz].tarnkp_max=2;
  
    /* 4.Runde */
    ebz++;
    ebn[ebz].hell=-15;
    ebn[ebz].freib=ebn[ebz].mauer=2;
    ebn[ebz].musnr=2;
    ebn[ebz].en_anz=5;
    ebn[ebz].en_max=35;
    for (i1=0;i1<ebn[ebz].en_max;i1++) {  /* (0,)1,2(,3) */
      if ((i2=ZUFALL(7)/1)>=1) {i2=1+ZUFALL(10)/5;}
      ebn[ebz].gattung[i1]=i2;
      ebn[ebz].warte_max[i1]=500+ZUFALL(180)-90;
    }
    ebn[ebz].gattung[ebn[ebz].en_max-13]=3;
    ebn[ebz].gattung[ebn[ebz].en_max-6]=3;
    ebn[ebz].gattung[ebn[ebz].en_max-2]=3;
    ebn[ebz].giftfl_weg=900;
    ebn[ebz].giftfl_da=800;
    ebn[ebz].giftfl_max=9;
    ebn[ebz].tarnkp_weg=2600;
    ebn[ebz].tarnkp_da=800;
    ebn[ebz].tarnkp_max=2;
  
    /* 5.Runde */
    ebz++;
    ebn[ebz].hell=0;
    ebn[ebz].freib=ebn[ebz].mauer=3;
    ebn[ebz].musnr=3;
    ebn[ebz].en_anz=4;
    ebn[ebz].en_max=32;
    for (i1=0;i1<ebn[ebz].en_max;i1++) {  /* 1,2,3(,4) */
      if ((i2=ZUFALL(10)/5)==0) {i2=1+ZUFALL(10)/5;} else {i2=3;}
      ebn[ebz].gattung[i1]=i2;
      ebn[ebz].warte_max[i1]=600+ZUFALL(150)-75;
    }
    ebn[ebz].gattung[ebn[ebz].en_max-12]=4;
    ebn[ebz].gattung[ebn[ebz].en_max-8]=4;
    ebn[ebz].gattung[ebn[ebz].en_max-3]=4;
    ebn[ebz].giftfl_weg=900;
    ebn[ebz].giftfl_da=800;
    ebn[ebz].giftfl_max=9;
    ebn[ebz].tarnkp_weg=2800;
    ebn[ebz].tarnkp_da=800;
    ebn[ebz].tarnkp_max=2;
  
    /* 6.Runde */
    ebz++;
    ebn[ebz].hell=-15;
    ebn[ebz].freib=ebn[ebz].mauer=3;
    ebn[ebz].musnr=3;
    ebn[ebz].en_anz=5;
    ebn[ebz].en_max=30;
    for (i1=0;i1<ebn[ebz].en_max;i1++) {  /* (1,2,)3,4 */
      if ((i2=ZUFALL(10)/3)==0) {i2=1+ZUFALL(10)/5;}
      else if ((i2=ZUFALL(10)/5)==0) {i2=3;} else {i2=4;}
      ebn[ebz].gattung[i1]=i2;
      ebn[ebz].warte_max[i1]=600+ZUFALL(120)-60;
    }
    ebn[ebz].giftfl_weg=900;
    ebn[ebz].giftfl_da=800;
    ebn[ebz].giftfl_max=10;
    ebn[ebz].tarnkp_weg=2900;
    ebn[ebz].tarnkp_da=800;
    ebn[ebz].tarnkp_max=2;
  
    /* 7.Runde */
    ebz++;
    ebn[ebz].hell=0;
    ebn[ebz].freib=ebn[ebz].mauer=4;
    ebn[ebz].musnr=4;
    ebn[ebz].en_anz=3;
    ebn[ebz].en_max=40;
    for (i1=0;i1<ebn[ebz].en_max;i1++) {  /* (0,)1,2,(3,)4 */
      if ((i2=ZUFALL(10)/1)==0) {i2=0;}
      else if ((i2=ZUFALL(10)/3)==0) {i2=1+ZUFALL(10)/5;}
      else if ((i2=ZUFALL(10)/3)==0) {i2=3;} else {i2=4;}
      ebn[ebz].gattung[i1]=i2;
      ebn[ebz].warte_max[i1]=800+ZUFALL(160)-80;
    }
    ebn[ebz].giftfl_weg=900;
    ebn[ebz].giftfl_da=800;
    ebn[ebz].giftfl_max=10;
    ebn[ebz].tarnkp_weg=3000;
    ebn[ebz].tarnkp_da=800;
    ebn[ebz].tarnkp_max=2;
  
    /* 8.Runde */
    ebz++;
    ebn[ebz].hell=-15;
    ebn[ebz].freib=ebn[ebz].mauer=4;
    ebn[ebz].musnr=4;
    ebn[ebz].en_anz=5;
    ebn[ebz].en_max=35;
    for (i1=0;i1<ebn[ebz].en_max;i1++) {  /* (0,)1,2,(3,)4(,5) */
      if ((i2=ZUFALL(10)/1)==0) {i2=0;}
      else if ((i2=ZUFALL(10)/3)==0) {i2=1+ZUFALL(10)/5;}
      else if ((i2=ZUFALL(10)/3)==0) {i2=3;} else {i2=4;}
      ebn[ebz].gattung[i1]=i2;
      ebn[ebz].warte_max[i1]=800+ZUFALL(160)-80;
    }
    ebn[ebz].gattung[ebn[ebz].en_max-4]=5;
    ebn[ebz].gattung[ebn[ebz].en_max-1]=5;
    ebn[ebz].giftfl_weg=900;
    ebn[ebz].giftfl_da=800;
    ebn[ebz].giftfl_max=11;
    ebn[ebz].tarnkp_weg=3300;
    ebn[ebz].tarnkp_da=800;
    ebn[ebz].tarnkp_max=2;
  
    /* 9.Runde */
    ebz++;
    ebn[ebz].hell=0;
    ebn[ebz].freib=ebn[ebz].mauer=5;
    ebn[ebz].musnr=5;
    ebn[ebz].en_anz=3;
    ebn[ebz].en_max=25;
    for (i1=0;i1<ebn[ebz].en_max;i1++) {  /* (1,2,3,4,),5(,6) */
      if ((i2=ZUFALL(10)/1)==0) {i2=1+ZUFALL(10)/5;}
      else if ((i2=ZUFALL(10)/4)==0) {i2=4;} else {i2=5;}
      ebn[ebz].gattung[i1]=i2;
      ebn[ebz].warte_max[i1]=900+ZUFALL(130)-65;
    }
    ebn[ebz].gattung[ebn[ebz].en_max-1]=6;
    ebn[ebz].giftfl_weg=800;
    ebn[ebz].giftfl_da=800;
    ebn[ebz].giftfl_max=15;
    ebn[ebz].tarnkp_weg=3500;
    ebn[ebz].tarnkp_da=800;
    ebn[ebz].tarnkp_max=3;
  
    /* 10.Runde */
    ebz++;
    ebn[ebz].hell=-15;
    ebn[ebz].freib=6;
    ebn[ebz].mauer=5;
    ebn[ebz].musnr=5;
    ebn[ebz].en_anz=2;
    ebn[ebz].en_max=4;
    for (i1=0;i1<ebn[ebz].en_max;i1++) {  /* 6 */
      ebn[ebz].gattung[i1]=6;
      ebn[ebz].warte_max[i1]=1500+ZUFALL(200)-50;
    }
    ebn[ebz].giftfl_weg=1000;
    ebn[ebz].giftfl_da=800;
    ebn[ebz].giftfl_max=5;
    ebn[ebz].tarnkp_weg=5000;
    ebn[ebz].tarnkp_da=800;
    ebn[ebz].tarnkp_max=0;

  } else if (atoi(argv[1])==2) {  /* schwer */
    /* 1.Runde */
    ebz=0;
    ebn[ebz].hell=0;
    ebn[ebz].freib=ebn[ebz].mauer=1;
    ebn[ebz].musnr=1;
    ebn[ebz].en_anz=4;
    ebn[ebz].en_max=24;
    for (i1=0;i1<ebn[ebz].en_max;i1++) {  /* 0 */
      ebn[ebz].gattung[i1]=0;
      ebn[ebz].warte_max[i1]=500+ZUFALL(100)-50;
    }
    ebn[ebz].gattung[ebn[ebz].en_max-5]=1;
    ebn[ebz].gattung[ebn[ebz].en_max-2]=1;
    ebn[ebz].giftfl_weg=2000;
    ebn[ebz].giftfl_da=800;
    ebn[ebz].giftfl_max=3;
    ebn[ebz].tarnkp_weg=3000;
    ebn[ebz].tarnkp_da=800;
    ebn[ebz].tarnkp_max=1;
  
    /* 2.Runde */
    ebz++;
    ebn[ebz].hell=-15;
    ebn[ebz].freib=ebn[ebz].mauer=1;
    ebn[ebz].musnr=1;
    ebn[ebz].en_anz=6;
    ebn[ebz].en_max=48;
    for (i1=0;i1<ebn[ebz].en_max;i1++) {  /* 0(,1,2) */
      if ((i2=ZUFALL(7)/5)>=1) {i2=1+ZUFALL(10)/5;}
      ebn[ebz].gattung[i1]=i2;
      ebn[ebz].warte_max[i1]=500+ZUFALL(160)-80;
    }
    ebn[ebz].giftfl_weg=1700;
    ebn[ebz].giftfl_da=800;
    ebn[ebz].giftfl_max=5;
    ebn[ebz].tarnkp_weg=3500;
    ebn[ebz].tarnkp_da=800;
    ebn[ebz].tarnkp_max=1;
  
    /* 3.Runde */
    ebz++;
    ebn[ebz].hell=0;
    ebn[ebz].freib=ebn[ebz].mauer=2;
    ebn[ebz].musnr=2;
    ebn[ebz].en_anz=5;
    ebn[ebz].en_max=36;
    for (i1=0;i1<ebn[ebz].en_max;i1++) {  /* (0,)1,2 */
      if ((i2=ZUFALL(7)/3)>=1) {i2=1+ZUFALL(10)/5;}
      ebn[ebz].gattung[i1]=i2;
      ebn[ebz].warte_max[i1]=500+ZUFALL(180)-90;
    }
    ebn[ebz].giftfl_weg=1600;
    ebn[ebz].giftfl_da=800;
    ebn[ebz].giftfl_max=5;
    ebn[ebz].tarnkp_weg=4000;
    ebn[ebz].tarnkp_da=800;
    ebn[ebz].tarnkp_max=1;
  
    /* 4.Runde */
    ebz++;
    ebn[ebz].hell=-15;
    ebn[ebz].freib=ebn[ebz].mauer=2;
    ebn[ebz].musnr=2;
    ebn[ebz].en_anz=7;
    ebn[ebz].en_max=52;
    for (i1=0;i1<ebn[ebz].en_max;i1++) {  /* (0,)1,2(,3) */
      if ((i2=ZUFALL(7)/1)>=1) {i2=1+ZUFALL(10)/5;}
      ebn[ebz].gattung[i1]=i2;
      ebn[ebz].warte_max[i1]=500+ZUFALL(180)-90;
    }
    ebn[ebz].gattung[ebn[ebz].en_max-13]=3;
    ebn[ebz].gattung[ebn[ebz].en_max-6]=3;
    ebn[ebz].gattung[ebn[ebz].en_max-2]=3;
    ebn[ebz].giftfl_weg=1500;
    ebn[ebz].giftfl_da=800;
    ebn[ebz].giftfl_max=7;
    ebn[ebz].tarnkp_weg=4200;
    ebn[ebz].tarnkp_da=800;
    ebn[ebz].tarnkp_max=1;
  
    /* 5.Runde */
    ebz++;
    ebn[ebz].hell=0;
    ebn[ebz].freib=ebn[ebz].mauer=3;
    ebn[ebz].musnr=3;
    ebn[ebz].en_anz=6;
    ebn[ebz].en_max=42;
    for (i1=0;i1<ebn[ebz].en_max;i1++) {  /* 1,2,3(,4) */
      if ((i2=ZUFALL(10)/5)==0) {i2=1+ZUFALL(10)/5;} else {i2=3;}
      ebn[ebz].gattung[i1]=i2;
      ebn[ebz].warte_max[i1]=600+ZUFALL(150)-75;
    }
    ebn[ebz].gattung[ebn[ebz].en_max-12]=4;
    ebn[ebz].gattung[ebn[ebz].en_max-8]=4;
    ebn[ebz].gattung[ebn[ebz].en_max-3]=4;
    ebn[ebz].giftfl_weg=1400;
    ebn[ebz].giftfl_da=800;
    ebn[ebz].giftfl_max=7;
    ebn[ebz].tarnkp_weg=4500;
    ebn[ebz].tarnkp_da=800;
    ebn[ebz].tarnkp_max=1;
  
    /* 6.Runde */
    ebz++;
    ebn[ebz].hell=-15;
    ebn[ebz].freib=ebn[ebz].mauer=3;
    ebn[ebz].musnr=3;
    ebn[ebz].en_anz=7;
    ebn[ebz].en_max=50;
    for (i1=0;i1<ebn[ebz].en_max;i1++) {  /* (1,2,)3,4 */
      if ((i2=ZUFALL(10)/3)==0) {i2=1+ZUFALL(10)/5;}
      else if ((i2=ZUFALL(10)/5)==0) {i2=3;} else {i2=4;}
      ebn[ebz].gattung[i1]=i2;
      ebn[ebz].warte_max[i1]=600+ZUFALL(120)-60;
    }
    ebn[ebz].giftfl_weg=1200;
    ebn[ebz].giftfl_da=800;
    ebn[ebz].giftfl_max=8;
    ebn[ebz].tarnkp_weg=4600;
    ebn[ebz].tarnkp_da=800;
    ebn[ebz].tarnkp_max=1;
  
    /* 7.Runde */
    ebz++;
    ebn[ebz].hell=0;
    ebn[ebz].freib=ebn[ebz].mauer=4;
    ebn[ebz].musnr=4;
    ebn[ebz].en_anz=5;
    ebn[ebz].en_max=65;
    for (i1=0;i1<ebn[ebz].en_max;i1++) {  /* (0,)1,2,(3,)4 */
      if ((i2=ZUFALL(10)/1)==0) {i2=0;}
      else if ((i2=ZUFALL(10)/3)==0) {i2=1+ZUFALL(10)/5;}
      else if ((i2=ZUFALL(10)/3)==0) {i2=3;} else {i2=4;}
      ebn[ebz].gattung[i1]=i2;
      ebn[ebz].warte_max[i1]=800+ZUFALL(160)-80;
    }
    ebn[ebz].giftfl_weg=1500;
    ebn[ebz].giftfl_da=800;
    ebn[ebz].giftfl_max=8;
    ebn[ebz].tarnkp_weg=4700;
    ebn[ebz].tarnkp_da=800;
    ebn[ebz].tarnkp_max=1;
  
    /* 8.Runde */
    ebz++;
    ebn[ebz].hell=-15;
    ebn[ebz].freib=ebn[ebz].mauer=4;
    ebn[ebz].musnr=4;
    ebn[ebz].en_anz=8;
    ebn[ebz].en_max=53;
    for (i1=0;i1<ebn[ebz].en_max;i1++) {  /* (0,)1,2,(3,)4(,5) */
      if ((i2=ZUFALL(10)/1)==0) {i2=0;}
      else if ((i2=ZUFALL(10)/3)==0) {i2=1+ZUFALL(10)/5;}
      else if ((i2=ZUFALL(10)/3)==0) {i2=3;} else {i2=4;}
      ebn[ebz].gattung[i1]=i2;
      ebn[ebz].warte_max[i1]=800+ZUFALL(160)-80;
    }
    ebn[ebz].gattung[ebn[ebz].en_max-4]=5;
    ebn[ebz].gattung[ebn[ebz].en_max-1]=5;
    ebn[ebz].giftfl_weg=1200;
    ebn[ebz].giftfl_da=800;
    ebn[ebz].giftfl_max=9;
    ebn[ebz].tarnkp_weg=4800;
    ebn[ebz].tarnkp_da=800;
    ebn[ebz].tarnkp_max=1;
  
    /* 9.Runde */
    ebz++;
    ebn[ebz].hell=0;
    ebn[ebz].freib=ebn[ebz].mauer=5;
    ebn[ebz].musnr=5;
    ebn[ebz].en_anz=4;
    ebn[ebz].en_max=38;
    for (i1=0;i1<ebn[ebz].en_max;i1++) {  /* (1,2,3,4,),5(,6) */
      if ((i2=ZUFALL(10)/1)==0) {i2=1+ZUFALL(10)/5;}
      else if ((i2=ZUFALL(10)/4)==0) {i2=4;} else {i2=5;}
      ebn[ebz].gattung[i1]=i2;
      ebn[ebz].warte_max[i1]=900+ZUFALL(130)-65;
    }
    ebn[ebz].gattung[ebn[ebz].en_max-1]=6;
    ebn[ebz].giftfl_weg=1000;
    ebn[ebz].giftfl_da=800;
    ebn[ebz].giftfl_max=12;
    ebn[ebz].tarnkp_weg=4900;
    ebn[ebz].tarnkp_da=800;
    ebn[ebz].tarnkp_max=2;
  
    /* 10.Runde */
    ebz++;
    ebn[ebz].hell=-15;
    ebn[ebz].freib=6;
    ebn[ebz].mauer=5;
    ebn[ebz].musnr=5;
    ebn[ebz].en_anz=3;
    ebn[ebz].en_max=7;
    for (i1=0;i1<ebn[ebz].en_max;i1++) {  /* 6 */
      ebn[ebz].gattung[i1]=6;
      ebn[ebz].warte_max[i1]=1500+ZUFALL(200)-50;
    }
    ebn[ebz].giftfl_weg=1200;
    ebn[ebz].giftfl_da=800;
    ebn[ebz].giftfl_max=5;
    ebn[ebz].tarnkp_weg=5000;
    ebn[ebz].tarnkp_da=800;
    ebn[ebz].tarnkp_max=0;

  }

  /* rausschreiben */
  fwrite(ebn,sizeof(ebn),1,stdout);
  return(0);
}
