/* *****************************************************************
   MrSnake: game for vgagames
   Copyright (C) 2003 Kurt Nienhaus

   This program is modifiable/redistributable under the terms
   of the GNU General Public Licence as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
   ***************************************************************** */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <time.h>
#include <vgagames.h>
#include "mrsnake.h"
#include "pfad.h"
#include "sprache.h"
#include "sound_volume_settings.h"

void intro(void);
char * game(void);
int menu(int);
void menu_help(int,int,int,int,int [2]);
void menu_sound(int,int,int,int,int [2],int);
void zw_seq(int);
void extro(void);
void setze_keys(int);
void setze_sound(int);
void end_err(const char *,const char *);
char * _zeige_schild(grafik *,int);
void _intro_film(film *,void *,int);

#if !defined(SPRACHE) || SPRACHE <= 1
  static const char titel[]="Mr. Snake";
  static const char utitel[]="";
#elif SPRACHE == 2
  static const char titel[]="Mr. Snake";
  static const char utitel[]="";
#endif
static int vol_g=50,vol_m=50,vol_s=50;
my_snake sn_i;
enemy_snake sn_e[EB_EN_MAX];
ebene ebn;
int volm,volp;
int ikopf,iglied;
int ekopf,eglied[ES_ANZ];
int zgiftflx,zgiftfly,ztarnkpx,ztarnkpy,zaugex,zaugey;
int i_stream,e_stream;
short * i_streamx,* i_streamy,* i_streamz;
short * e_streamx[EB_EN_MAX],* e_streamy[EB_EN_MAX],* e_streamz[EB_EN_MAX];
grafik * i_gifth,* i_giftv,* e_gifth1[2],* e_gifth2[2],* e_giftv1[2],* e_giftv2[2];
grafik * auge[2],* gi_kopf[4],* gi_glied[4],* ge_kopf[4],* ge_oberkopf[4];
int giftx,gifty;
grafik * esymbol[ES_ANZ],* zunge0,* zunge1,* zunge2,* zunge3;
int wv[128],cnn[3];
int gamelevel=0;

#define SND_TEST             wv[0]
#define MUS_TEST             wv[1]
#define SND_I_GIFTSPRITZEN   wv[2]
#define SND_I_GIFTGETROFFEN  wv[3]
#define SND_E_KOMMT          wv[4]
#define SND_E_GIFTGETROFFEN  wv[5]
#define SND_E_GEFRESSEN      wv[6]
#define SND_GIFTFLASCHE      wv[7]
#define SND_TARNKAPPE        wv[8]
#define SND_GAMEOVER         wv[9]
#define SND_KRIECH           wv[10]
#define SND_BRUELL           wv[11]
#define SND_WAND             wv[12]
#define MUS_INTRO            wv[13]
#define MUS_EXTRO            wv[14]
#define MUS_NR(A)            wv[14+A]

#define AN_ECKEN(P1,P2,P3,P4)  (get_pixel(hoehle_maske,P1-P3,P2-P4) \
                               || get_pixel(hoehle_maske,P1+P3,P2-P4) \
                               || get_pixel(hoehle_maske,P1+P3,P2+P4) \
                               || get_pixel(hoehle_maske,P1-P3,P2+P4) \
                               || get_pixel(hoehle_maske,P1,P2))

#define I_STREAM_MOVE  \
                  memmove(i_streamx+1,i_streamx,i_stream*sizeof(short)-sizeof(short)); \
                  i_streamx[0]=(short)sn_i.x; \
                  memmove(i_streamy+1,i_streamy,i_stream*sizeof(short)-sizeof(short)); \
                  i_streamy[0]=(short)sn_i.y; \
                  memmove(i_streamz+1,i_streamz,i_stream*sizeof(short)-sizeof(short)); \
                  i_streamz[0]=(short)sn_i.z;

#define E_STREAM_MOVE(P1)  \
                  memmove(e_streamx[P1]+1,e_streamx[P1],e_stream*sizeof(short)-sizeof(short)); \
                  e_streamx[P1][0]=(short)sn_e[P1].x; \
                  memmove(e_streamy[P1]+1,e_streamy[P1],e_stream*sizeof(short)-sizeof(short)); \
                  e_streamy[P1][0]=(short)sn_e[P1].y; \
                  memmove(e_streamz[P1]+1,e_streamz[P1],e_stream*sizeof(short)-sizeof(short)); \
                  e_streamz[P1][0]=(short)sn_e[P1].z;

#define TESTE_ESNAKE(P1,P2)  \
     P2=0; \
     if (sn_e[P1].tarnkappe<=0) { \
       if ((sn_e[P1].x-ekopf<=sn_i.x+ikopf) \
       && (sn_e[P1].x+ekopf>=sn_i.x-ikopf) \
       && (sn_e[P1].y-ekopf<=sn_i.y+ikopf) \
       && (sn_e[P1].y+ekopf>=sn_i.y-ikopf)) { \
         if (frisst_en>=0) {sn_e[frisst_en].aktiv=0;} \
         frisst_en=P1; frisst_zhl=sn_e[P1].glied_mom*10; P2=1; \
         if ((sn_i.tarnkappe<=0) && (sn_i.glied_mom<sn_e[P1].glied_mom)) { \
           sn_i.glied_mom-=(sn_e[P1].glied_mom-sn_i.glied_mom); \
           play_wave(SND_I_GIFTGETROFFEN,cnn[1],0,0); \
         } \
         play_wave(SND_E_GEFRESSEN,cnn[2],0,0); \
         punkte+=sn_e[P1].glied_mom; \
       } else { \
         int a1; \
         for (a1=0;a1<IS_GIFT_MAX;a1++) { \
           if (sn_i.gift[a1].aktiv==0) {continue;} \
           if ((sn_e[P1].x-ekopf<=sn_i.gift[a1].x+sn_i.gift[a1].w) \
           && (sn_e[P1].x+ekopf>=sn_i.gift[a1].x-sn_i.gift[a1].w) \
           && (sn_e[P1].y-ekopf<=sn_i.gift[a1].y+sn_i.gift[a1].h) \
           && (sn_e[P1].y+ekopf>=sn_i.gift[a1].y-sn_i.gift[a1].h)) { \
             sn_i.gift[a1].aktiv=0; \
             if (--sn_e[P1].glied_mom<=0) { \
               play_wave(SND_E_GEFRESSEN,cnn[2],0,0); \
               sn_e[P1].aktiv=0; \
               P2=1; \
             } else { \
               play_wave(SND_E_GIFTGETROFFEN,cnn[2],0,0); \
               if (sn_i.gift[a1].xplus>0) {P2=12;} \
               else if (sn_i.gift[a1].yplus>0) {P2=13;} \
               else if (sn_i.gift[a1].xplus<0) {P2=10;} \
               else if (sn_i.gift[a1].yplus<0) {P2=11;} \
             } \
             punkte++; \
           } \
         } \
       } \
     }

#define TESTE_EGIFT(P1,P2)  \
     if ((sn_i.tarnkappe<=0) \
     && (sn_e[P1].gift[P2].x-sn_e[P1].gift[P2].w<=sn_i.x+ikopf) \
     && (sn_e[P1].gift[P2].x+sn_e[P1].gift[P2].w>=sn_i.x-ikopf) \
     && (sn_e[P1].gift[P2].y-sn_e[P1].gift[P2].h<=sn_i.y+ikopf) \
     && (sn_e[P1].gift[P2].y+sn_e[P1].gift[P2].h>=sn_i.y-ikopf)) { \
       sn_e[P1].gift[P2].aktiv=0; sn_e[P1].gzhl=0; \
       sn_i.glied_mom-=enemy_art[sn_e[P1].gattung].gift_stark; \
       play_wave(SND_I_GIFTGETROFFEN,cnn[1],0,0); \
     } else { \
       int a1; \
       for (a1=0;a1<IS_GIFT_MAX;a1++) { \
         if (sn_i.gift[a1].aktiv==0) {continue;} \
         if ((sn_e[P1].gift[P2].x-sn_e[P1].gift[P2].w<=sn_i.gift[a1].x+sn_i.gift[a1].w) \
         && (sn_e[P1].gift[P2].x+sn_e[P1].gift[P2].w>=sn_i.gift[a1].x-sn_i.gift[a1].w) \
         && (sn_e[P1].gift[P2].y-sn_e[P1].gift[P2].h<=sn_i.gift[a1].y+sn_i.gift[a1].h) \
         && (sn_e[P1].gift[P2].y+sn_e[P1].gift[P2].h>=sn_i.gift[a1].y-sn_i.gift[a1].h)) { \
           sn_i.gift[a1].aktiv=0; \
           sn_e[P1].gift[P2].aktiv=0; sn_e[P1].gzhl=0; \
         } \
       } \
     }

#define TESTE_IZUSATZ  \
     if ((giftfl.aktiv) && (sn_i.glied_mom<sn_i.glied_max) \
     && (sn_i.x-ikopf<=giftfl.x+zgiftflx) \
     && (sn_i.x+ikopf>=giftfl.x-zgiftflx) \
     && (sn_i.y-ikopf<=giftfl.y+zgiftfly) \
     && (sn_i.y+ikopf>=giftfl.y-zgiftfly)) { \
       giftfl.aktiv=0; \
       ebn.giftfl_zhl=ebn.giftfl_weg; \
       sn_i.glied_mom++; \
       play_wave(SND_GIFTFLASCHE,cnn[1],0,0); \
     } \
     if ((tarnkp.aktiv) && (sn_i.tarnkappe<=0) \
     && (sn_i.x-ikopf<=tarnkp.x+ztarnkpx) \
     && (sn_i.x+ikopf>=tarnkp.x-ztarnkpx) \
     && (sn_i.y-ikopf<=tarnkp.y+ztarnkpy) \
     && (sn_i.y+ikopf>=tarnkp.y-ztarnkpy)) { \
       tarnkp.aktiv=0; \
       ebn.tarnkp_zhl=ebn.tarnkp_weg; \
       sn_i.tarnkappe=500; \
       play_wave(SND_TARNKAPPE,cnn[1],0,0); \
     }

#define TESTE_EZUSATZ(P1)  \
     if ((giftfl.aktiv) \
     && (sn_e[P1].glied_mom<enemy_art[sn_e[P1].gattung].glied_max) \
     && (sn_e[P1].x-ekopf<=giftfl.x+zgiftflx) \
     && (sn_e[P1].x+ekopf>=giftfl.x-zgiftflx) \
     && (sn_e[P1].y-ekopf<=giftfl.y+zgiftfly) \
     && (sn_e[P1].y+ekopf>=giftfl.y-zgiftfly)) { \
       giftfl.aktiv=0; \
       ebn.giftfl_zhl=ebn.giftfl_weg; \
       sn_e[P1].glied_mom++; \
       play_wave(SND_GIFTFLASCHE,cnn[2],0,0); \
     } \
     if ((tarnkp.aktiv) && (sn_e[P1].tarnkappe<=0) \
     && (sn_e[P1].x-ekopf<=tarnkp.x+ztarnkpx) \
     && (sn_e[P1].x+ekopf>=tarnkp.x-ztarnkpx) \
     && (sn_e[P1].y-ekopf<=tarnkp.y+ztarnkpy) \
     && (sn_e[P1].y+ekopf>=tarnkp.y-ztarnkpy)) { \
       tarnkp.aktiv=0; \
       ebn.tarnkp_zhl=ebn.tarnkp_weg; \
       sn_e[P1].tarnkappe=500; \
       play_wave(SND_TARNKAPPE,cnn[2],0,0); \
     }

#define MENU_BILD(P1,X1,Y1,X2,Y2,Y0) \
   {int i1,i2,i3; \
    draw_fillbox(NULL,X1+7,Y1+7,X2-X1,Y2-Y1,RGB_BLACK); \
    draw_fillbox(NULL,X1,Y1,X2-X1,Y2-Y1,color_index(CL_BLUE,30)); \
    if (P1&1) { \
      for (i2=0,i3=-1,i1=X1+5;i1<=X2-5;i1++) { \
        i2+=i3; if ((i2==-2) || (i2==2)) {i3=-i3;} \
        draw_pixel(NULL,i1,Y1+5+i2,RGB_WHITE); \
      } \
    } else {draw_line(NULL,X1+5,Y1+5,X2-5,Y1+5,RGB_WHITE);} \
    if (P1&2) { \
      for (i2=0,i3=1,i1=X1+5;i1<=X2-5;i1++) { \
        i2+=i3; if ((i2==-2) || (i2==2)) {i3=-i3;} \
        draw_pixel(NULL,i1,Y2-5+i2,RGB_WHITE); \
      } \
    } else {draw_line(NULL,X1+5,Y2-5,X2-5,Y2-5,RGB_WHITE);} \
    draw_line(NULL,X1+5,Y1+5,X1+5,Y2-5,RGB_WHITE); \
    draw_line(NULL,X2-5,Y1+5,X2-5,Y2-5,RGB_WHITE); \
    Y0=Y1+10; \
    set_font(font10x17,10,17); \
    draw_text(NULL,RGB_WHITE,X1+(X2-X1-(sizeof(titel)-1)*10)/2,Y0,titel,sizeof(titel)-1,RGB_TRANS); \
    set_font(NULL,0,0); \
    Y0+=17+2; \
    draw_text(NULL,RGB_WHITE,X1+(X2-X1-(sizeof(utitel)-1)*8)/2,Y0,utitel,sizeof(utitel)-1,RGB_TRANS); \
    Y0+=8+11; \
   }


int main(int argc,char ** argv) {
  int i1,i2,ix,iy,iw,ih;
  char buf[1024],* ptr;
  FILE * ffp;

  /* +++ Initialisierung +++ */
  srand(time(NULL)%1000);
  i1=0;
#ifdef WINDOW_RESIZABLE
  printf("Usage: %s [-1 to -4] [-f]\n",argv[0]);
  if (argc>=2) {
    int n1,n2;
    n1=n2=0;
    if (strcmp(argv[1],"-f")==0) {n2=VGAWINDOW_FULL;}
    else {n1=atoi(argv[1]+1);}
    if (argc>=3) {
      if (strcmp(argv[2],"-f")==0) {n2=VGAWINDOW_FULL;}
      else {n1=atoi(argv[2]+1);}
    }
    if (n1==1) {i1=VGAWINDOW_1;}
    else if (n1==2) {i1=VGAWINDOW_2;}
    else if (n1==3) {i1=VGAWINDOW_3;}
    else if (n1==4) {i1=VGAWINDOW_4;}
    i1+=n2;
  }
#endif

  if (open_window(titel,i1)!=0) {fprintf(stderr,"%s\n",errmsg); exit(1);}
  if (init_sound(11025,0)!=0) {end_err(argv[0],"Init sound");}
  volm=set_vol(-1,0);
  volp=set_vol(-1,1);
  cnn[0]=CN_(1);  /* Musikkanal */
  cnn[1]=CN_(2);  /* Soundkanal eigene Schlange */
  cnn[2]=CN_(3)|CN_(4)|CN_(5);  /* Soundkanal FeindSchlange */

  /* +++ Sound laden +++ */
  ptr=buf+sprintf(buf,"%s/sound/",INST_PFAD);
  strcpy(ptr,"sndtest.wav");
  SND_TEST=load_wave(buf,TYP_IS_WAVE);
  strcpy(ptr,"mustest.mid");
  MUS_TEST=load_wave(buf,TYP_IS_MIDI);
  strcpy(ptr,"is_giftspritzen.wav");
  SND_I_GIFTSPRITZEN=load_wave(buf,TYP_IS_WAVE);
  strcpy(ptr,"is_giftgetroffen.wav");
  SND_I_GIFTGETROFFEN=load_wave(buf,TYP_IS_WAVE);
  strcpy(ptr,"fs_kommt.wav");
  SND_E_KOMMT=load_wave(buf,TYP_IS_WAVE);
  strcpy(ptr,"fs_giftgetroffen.wav");
  SND_E_GIFTGETROFFEN=load_wave(buf,TYP_IS_WAVE);
  strcpy(ptr,"fs_gefressen.wav");
  SND_E_GEFRESSEN=load_wave(buf,TYP_IS_WAVE);
  strcpy(ptr,"giftflasche.wav");
  SND_GIFTFLASCHE=load_wave(buf,TYP_IS_WAVE);
  strcpy(ptr,"tarnkappe.wav");
  SND_TARNKAPPE=load_wave(buf,TYP_IS_WAVE);
  strcpy(ptr,"gamov.wav");
  SND_GAMEOVER=load_wave(buf,TYP_IS_WAVE);
  strcpy(ptr,"kriech.wav");
  SND_KRIECH=load_wave(buf,TYP_IS_WAVE);
  strcpy(ptr,"bruell.wav");
  SND_BRUELL=load_wave(buf,TYP_IS_WAVE);
  strcpy(ptr,"wand.wav");
  SND_WAND=load_wave(buf,TYP_IS_WAVE);
  strcpy(ptr,"intro.mid");
  MUS_INTRO=load_wave(buf,TYP_IS_MIDI);
  strcpy(ptr,"extro.mid");
  MUS_EXTRO=load_wave(buf,TYP_IS_MIDI);
  for (i1=1;i1<=99;i1++) {
    sprintf(ptr,"m%d.mid",i1);
    if ((ffp=fopen(buf,"r"))==NULL) {break;}
    fclose(ffp);
    MUS_NR(i1)=load_wave(buf,TYP_IS_MIDI);
  }
  /* Soundlautstaerke setzen */
  vol_g=sound_volume_settings(INST_PFAD"/save/sndvol.cfg",SND_TEST);
  if ((ffp=fopen(INST_PFAD"/save/chnvol.cfg","r"))!=NULL) {
    fscanf(ffp,"%d %d %d",&vol_g,&vol_m,&vol_s);
    fclose(ffp);
  }
  setze_sound(1|2|4);

  /* +++ Grafiken laden +++ */
  /* Symbole */
  for (i1=0;i1<ES_ANZ;i1++) {
    snprintf(buf,sizeof(buf),"%s/vga/esymbol%d.vga",INST_PFAD,i1);
    if ((esymbol[i1]=load_grafik(buf))==NULL) {end_err(argv[0],"Load graphic");}
  }

  /* Kopf in alle 4 Richtungen */
  if ((gi_kopf[3]=load_grafik(INST_PFAD"/vga/ikopf.vga"))==NULL) {end_err(argv[0],"Load graphic");}  /* rechts */
  iw=GRAFIK_WIDTH(gi_kopf[3]); ih=GRAFIK_HEIGHT(gi_kopf[3]);
  ikopf=(iw>ih?iw:ih);
  for (i1=0;i1<3;i1++) {
    if ((gi_kopf[i1]=create_grafik(ikopf,ikopf))==NULL) {end_err(argv[0],"Create graphic");}
    ix=iy=0; iw=GRAFIK_WIDTH(gi_kopf[3]); ih=GRAFIK_HEIGHT(gi_kopf[3]);
    if (rotate_grafik(gi_kopf[i1],gi_kopf[3],90*(i1+1),&ix,&iy,&iw,&ih)==NULL) {end_err(argv[0],"Rotate graphic");}
  }
  ikopf/=2;

  /* Glieder in alle 4 Richtungen */
  if ((gi_glied[3]=load_grafik(INST_PFAD"/vga/iglied.vga"))==NULL) {end_err(argv[0],"Load graphic");}  /* rechts */
  iw=GRAFIK_WIDTH(gi_glied[3]); ih=GRAFIK_HEIGHT(gi_glied[3]);
  iglied=(iw>ih?iw:ih);
  for (i1=0;i1<3;i1++) {
    if ((gi_glied[i1]=create_grafik(iglied,iglied))==NULL) {end_err(argv[0],"Create graphic");}
    ix=iy=0; iw=GRAFIK_WIDTH(gi_glied[3]); ih=GRAFIK_HEIGHT(gi_glied[3]);
    if (rotate_grafik(gi_glied[i1],gi_glied[3],90*(i1+1),&ix,&iy,&iw,&ih)==NULL) {end_err(argv[0],"Rotate graphic");}
  }
  iglied/=2;
  i_stream=MAXIMAL_GLIED*iglied*2-iglied+ikopf;
  if ((i_streamx=malloc(sizeof(short)*i_stream))==NULL) {end_err(argv[0],"allocation error");}
  if ((i_streamy=malloc(sizeof(short)*i_stream))==NULL) {end_err(argv[0],"allocation error");}
  if ((i_streamz=malloc(sizeof(short)*i_stream))==NULL) {end_err(argv[0],"allocation error");}

  /* Rest */
  if ((giftfl.bild[0]=load_grafik(INST_PFAD"/vga/giftfl1.vga"))==NULL) {end_err(argv[0],"Load graphic");}
  if ((giftfl.bild[1]=load_grafik(INST_PFAD"/vga/giftfl2.vga"))==NULL) {end_err(argv[0],"Load graphic");}
  zgiftflx=GRAFIK_WIDTH(giftfl.bild[0])>GRAFIK_WIDTH(giftfl.bild[1])?GRAFIK_WIDTH(giftfl.bild[0]):GRAFIK_WIDTH(giftfl.bild[1]);
  zgiftflx/=2;
  zgiftfly=GRAFIK_HEIGHT(giftfl.bild[0])>GRAFIK_HEIGHT(giftfl.bild[1])?GRAFIK_HEIGHT(giftfl.bild[0]):GRAFIK_HEIGHT(giftfl.bild[1]);
  zgiftfly/=2;
  if ((tarnkp.bild[0]=load_grafik(INST_PFAD"/vga/tarnkp1.vga"))==NULL) {end_err(argv[0],"Load graphic");}
  if ((tarnkp.bild[1]=load_grafik(INST_PFAD"/vga/tarnkp2.vga"))==NULL) {end_err(argv[0],"Load graphic");}
  ztarnkpx=GRAFIK_WIDTH(tarnkp.bild[0])>GRAFIK_WIDTH(tarnkp.bild[1])?GRAFIK_WIDTH(tarnkp.bild[0]):GRAFIK_WIDTH(tarnkp.bild[1]);
  ztarnkpx/=2;
  ztarnkpy=GRAFIK_HEIGHT(tarnkp.bild[0])>GRAFIK_HEIGHT(tarnkp.bild[1])?GRAFIK_HEIGHT(tarnkp.bild[0]):GRAFIK_HEIGHT(tarnkp.bild[1]);
  ztarnkpy/=2;
  if ((auge[0]=load_grafik(INST_PFAD"/vga/iauge.vga"))==NULL) {end_err(argv[0],"Load graphic");}
  if ((auge[1]=load_grafik(INST_PFAD"/vga/eauge.vga"))==NULL) {end_err(argv[0],"Load graphic");}
  zaugex=GRAFIK_WIDTH(auge[0])>GRAFIK_WIDTH(auge[1])?GRAFIK_WIDTH(auge[0]):GRAFIK_WIDTH(auge[1]);
  zaugey=GRAFIK_HEIGHT(auge[0])>GRAFIK_HEIGHT(auge[1])?GRAFIK_HEIGHT(auge[0]):GRAFIK_HEIGHT(auge[1]);
  zaugex/=2;
  zaugey/=2;
  i1=color_index(CL_RED,70);
  if ((zunge0=create_grafik(4,3))==NULL) {end_err(argv[0],"Create graphic");}
  draw_pixel(zunge0,0,1,i1); draw_pixel(zunge0,1,1,i1);
  draw_pixel(zunge0,2,0,i1); draw_pixel(zunge0,2,1,i1); draw_pixel(zunge0,2,2,i1);
  draw_pixel(zunge0,3,0,i1); draw_pixel(zunge0,3,2,i1);
  if ((zunge1=create_grafik(3,4))==NULL) {end_err(argv[0],"Create graphic");}
  draw_pixel(zunge1,1,0,i1); draw_pixel(zunge1,1,1,i1);
  draw_pixel(zunge1,0,2,i1); draw_pixel(zunge1,1,2,i1); draw_pixel(zunge1,2,2,i1);
  draw_pixel(zunge1,0,3,i1); draw_pixel(zunge1,2,3,i1);
  if ((zunge2=create_grafik(4,3))==NULL) {end_err(argv[0],"Create graphic");}
  draw_pixel(zunge2,0,0,i1); draw_pixel(zunge2,0,2,i1);
  draw_pixel(zunge2,1,0,i1); draw_pixel(zunge2,1,1,i1); draw_pixel(zunge2,1,2,i1);
  draw_pixel(zunge2,2,1,i1); draw_pixel(zunge2,3,1,i1);
  if ((zunge3=create_grafik(3,4))==NULL) {end_err(argv[0],"Create graphic");}
  draw_pixel(zunge3,0,0,i1); draw_pixel(zunge3,2,0,i1);
  draw_pixel(zunge3,0,1,i1); draw_pixel(zunge3,1,1,i1); draw_pixel(zunge3,2,1,i1);
  draw_pixel(zunge3,1,2,i1); draw_pixel(zunge3,1,3,i1);

  /* Feindschlangen */
  e_stream=0;
  snprintf(buf,sizeof(buf),"%s/vga/ekopf.vga",INST_PFAD);
  if ((ge_kopf[3]=load_grafik(buf))==NULL) {end_err(argv[0],"Load graphic");}
  iw=GRAFIK_WIDTH(ge_kopf[3]); ih=GRAFIK_HEIGHT(ge_kopf[3]);
  ekopf=(iw>ih?iw:ih);
  snprintf(buf,sizeof(buf),"%s/vga/eoberkopf.vga",INST_PFAD);
  if ((ge_oberkopf[3]=load_grafik(buf))==NULL) {end_err(argv[0],"Load graphic");}
  for (i2=0;i2<3;i2++) {
    if ((ge_kopf[i2]=create_grafik(ekopf,ekopf))==NULL) {end_err(argv[0],"Create graphic");}
    ix=iy=0; iw=GRAFIK_WIDTH(ge_kopf[3]); ih=GRAFIK_HEIGHT(ge_kopf[3]);
    if (rotate_grafik(ge_kopf[i2],ge_kopf[3],90*(i2+1),&ix,&iy,&iw,&ih)==NULL) {end_err(argv[0],"Rotate graphic");}
    if ((ge_oberkopf[i2]=create_grafik(ekopf,ekopf))==NULL) {end_err(argv[0],"Create graphic");}
    ix=iy=0; iw=GRAFIK_WIDTH(ge_oberkopf[3]); ih=GRAFIK_HEIGHT(ge_oberkopf[3]);
    if (rotate_grafik(ge_oberkopf[i2],ge_oberkopf[3],90*(i2+1),&ix,&iy,&iw,&ih)==NULL) {end_err(argv[0],"Rotate graphic");}
  }
  ekopf/=2;
  for (i1=0;i1<ES_ANZ;i1++) {
    snprintf(buf,sizeof(buf),"%s/vga/eglied%d.vga",INST_PFAD,i1);
    if ((enemy_art[i1].glied[3]=load_grafik(buf))==NULL) {end_err(argv[0],"Load graphic");}
    iw=GRAFIK_WIDTH(enemy_art[i1].glied[3]); ih=GRAFIK_HEIGHT(enemy_art[i1].glied[3]);
    eglied[i1]=(iw>ih?iw:ih);
    for (i2=0;i2<3;i2++) {
      if ((enemy_art[i1].glied[i2]=create_grafik(eglied[i1],eglied[i1]))==NULL) {end_err(argv[0],"Create graphic");}
      ix=iy=0; iw=GRAFIK_WIDTH(enemy_art[i1].glied[3]); ih=GRAFIK_HEIGHT(enemy_art[i1].glied[3]);
      if (rotate_grafik(enemy_art[i1].glied[i2],enemy_art[i1].glied[3],90*(i2+1),&ix,&iy,&iw,&ih)==NULL) {end_err(argv[0],"Rotate graphic");}
    }
    eglied[i1]/=2;
    i2=MAXIMAL_GLIED*eglied[i1]*2-eglied[i1]+ekopf;
    if (i2>e_stream) {e_stream=i2;}
  }
  for (i1=0;i1<EB_EN_MAX;i1++) {
    if ((e_streamx[i1]=malloc(sizeof(short)*e_stream))==NULL) {end_err(argv[0],"allocation error");}
    if ((e_streamy[i1]=malloc(sizeof(short)*e_stream))==NULL) {end_err(argv[0],"allocation error");}
    if ((e_streamz[i1]=malloc(sizeof(short)*e_stream))==NULL) {end_err(argv[0],"allocation error");}
  }

  /* Giftgrafiken erstellen */
  giftx=7; gifty=3;
  if ((i_gifth=create_grafik(giftx,gifty))==NULL) {end_err(argv[0],"Create graphic");}
  if ((e_gifth1[0]=create_grafik(giftx,gifty))==NULL) {end_err(argv[0],"Create graphic");}
  if ((e_gifth2[0]=create_grafik(giftx,gifty))==NULL) {end_err(argv[0],"Create graphic");}
  if ((e_gifth1[1]=create_grafik(giftx,gifty))==NULL) {end_err(argv[0],"Create graphic");}
  if ((e_gifth2[1]=create_grafik(giftx,gifty))==NULL) {end_err(argv[0],"Create graphic");}
  draw_line(i_gifth,0,1,giftx-1,1,color_index(CL_BLUE,100));
  i1=color_index(CL_GREEN,70);
  draw_pixel(e_gifth1[0],0,1,i1); draw_pixel(e_gifth1[0],1,0,i1);
  draw_pixel(e_gifth1[0],2,0,i1); draw_pixel(e_gifth1[0],3,1,i1);
  draw_pixel(e_gifth1[0],4,2,i1); draw_pixel(e_gifth1[0],5,2,i1);
  draw_pixel(e_gifth1[0],6,1,i1);
  draw_pixel(e_gifth2[0],0,1,i1); draw_pixel(e_gifth2[0],1,2,i1);
  draw_pixel(e_gifth2[0],2,2,i1); draw_pixel(e_gifth2[0],3,1,i1);
  draw_pixel(e_gifth2[0],4,0,i1); draw_pixel(e_gifth2[0],5,0,i1);
  draw_pixel(e_gifth2[0],6,1,i1);
  i1=color_index(CL_RED,100);
  draw_pixel(e_gifth1[1],0,1,i1); draw_pixel(e_gifth1[1],1,0,i1);
  draw_pixel(e_gifth1[1],2,0,i1); draw_pixel(e_gifth1[1],3,1,i1);
  draw_pixel(e_gifth1[1],4,2,i1); draw_pixel(e_gifth1[1],5,2,i1);
  draw_pixel(e_gifth1[1],6,1,i1);
  draw_pixel(e_gifth2[1],0,1,i1); draw_pixel(e_gifth2[1],1,2,i1);
  draw_pixel(e_gifth2[1],2,2,i1); draw_pixel(e_gifth2[1],3,1,i1);
  draw_pixel(e_gifth2[1],4,0,i1); draw_pixel(e_gifth2[1],5,0,i1);
  draw_pixel(e_gifth2[1],6,1,i1);
  if ((i_giftv=create_grafik(gifty,giftx))==NULL) {end_err(argv[0],"Create graphic");}
  if ((e_giftv1[0]=create_grafik(gifty,giftx))==NULL) {end_err(argv[0],"Create graphic");}
  if ((e_giftv2[0]=create_grafik(gifty,giftx))==NULL) {end_err(argv[0],"Create graphic");}
  if ((e_giftv1[1]=create_grafik(gifty,giftx))==NULL) {end_err(argv[0],"Create graphic");}
  if ((e_giftv2[1]=create_grafik(gifty,giftx))==NULL) {end_err(argv[0],"Create graphic");}
  draw_line(i_giftv,1,0,1,giftx-1,color_index(CL_BLUE,100));
  i1=color_index(CL_GREEN,70);
  draw_pixel(e_giftv1[0],1,0,i1); draw_pixel(e_giftv1[0],0,1,i1);
  draw_pixel(e_giftv1[0],0,2,i1); draw_pixel(e_giftv1[0],1,3,i1);
  draw_pixel(e_giftv1[0],2,4,i1); draw_pixel(e_giftv1[0],2,5,i1);
  draw_pixel(e_giftv1[0],1,6,i1);
  draw_pixel(e_giftv2[0],1,0,i1); draw_pixel(e_giftv2[0],2,1,i1);
  draw_pixel(e_giftv2[0],2,2,i1); draw_pixel(e_giftv2[0],1,3,i1);
  draw_pixel(e_giftv2[0],0,4,i1); draw_pixel(e_giftv2[0],0,5,i1);
  draw_pixel(e_giftv2[0],1,6,i1);
  i1=color_index(CL_RED,100);
  draw_pixel(e_giftv1[1],1,0,i1); draw_pixel(e_giftv1[1],0,1,i1);
  draw_pixel(e_giftv1[1],0,2,i1); draw_pixel(e_giftv1[1],1,3,i1);
  draw_pixel(e_giftv1[1],2,4,i1); draw_pixel(e_giftv1[1],2,5,i1);
  draw_pixel(e_giftv1[1],1,6,i1);
  draw_pixel(e_giftv2[1],1,0,i1); draw_pixel(e_giftv2[1],2,1,i1);
  draw_pixel(e_giftv2[1],2,2,i1); draw_pixel(e_giftv2[1],1,3,i1);
  draw_pixel(e_giftv2[1],0,4,i1); draw_pixel(e_giftv2[1],0,5,i1);
  draw_pixel(e_giftv2[1],1,6,i1);

  /* +++ Spiel ausfuehren +++ */
  clearstate();
  intro();
  clearstate();
  while (1) {
    if (menu(0)==1) {break;}
    if ((ptr=game())!=NULL) {end_err(argv[0],ptr);}
  }
  if ((ffp=fopen(INST_PFAD"/save/chnvol.cfg","w"))!=NULL) {
    fprintf(ffp,"%d %d %d",vol_g,vol_m,vol_s);
    fchmod(fileno(ffp),0666);
    fclose(ffp);
  }

  /* +++ Ende +++ */
  free(i_streamx);
  free(i_streamy);
  free(i_streamz);
  for (i1=0;i1<4;i1++) {
    free_grafik(gi_kopf[i1]);
    free_grafik(gi_glied[i1]);
    free_grafik(ge_kopf[i1]);
    free_grafik(ge_oberkopf[i1]);
  }
  free_grafik(i_gifth);
  free_grafik(i_giftv);
  free_grafik(e_gifth1[0]);
  free_grafik(e_gifth2[0]);
  free_grafik(e_giftv1[0]);
  free_grafik(e_giftv2[0]);
  free_grafik(e_gifth1[1]);
  free_grafik(e_gifth2[1]);
  free_grafik(e_giftv1[1]);
  free_grafik(e_giftv2[1]);
  free_grafik(giftfl.bild[0]);
  free_grafik(giftfl.bild[1]);
  free_grafik(tarnkp.bild[0]);
  free_grafik(tarnkp.bild[1]);
  for (i1=0;i1<EB_EN_MAX;i1++) {
    free(e_streamx[i1]);
    free(e_streamy[i1]);
    free(e_streamz[i1]);
  }
  for (i1=0;i1<ES_ANZ;i1++) {
    for (i2=0;i2<4;i2++) {
      free_grafik(enemy_art[i1].glied[i2]);
    }
  }
  free_grafik(zunge0);
  free_grafik(zunge1);
  free_grafik(zunge2);
  free_grafik(zunge3);
  set_vol(volm,0);
  set_vol(volp,1);
  end_sound();
  close_window();
  exit(0);
} /* Ende main */


void intro() {
  film * flm;
  film_bild bld;
  char buf[1024],* ptr;
  unsigned long l1;
  int i1;
  CLEAR_KEYS;
  ADD_KEYS(KEY_ENTER,SHORT_KEY);
  ADD_KEYS(KEY_Q,SHORT_KEY);
  ADD_KEYS(KEY_SPACE,SHORT_KEY);

  /* +++ Vorsequenz +++ */
  {int posx,posy,x,y,w,h,col;
   float f1;
   grafik * grf1,* grf2,* grf3;
   col=color_index(CL_BROWN,100);
   CLEAR_BOX(NULL,col);
   flush_window();
   sleep(1);
   snprintf(buf,sizeof(buf),"%s/film/vor0.vga",INST_PFAD);
   if ((grf1=load_grafik(buf))==NULL) {end_err("Intro","Load graphic");}
   w=GRAFIK_WIDTH(grf1);
   h=GRAFIK_HEIGHT(grf1);
   posx=(SC_WIDTH-w)/2;
   posy=(SC_HEIGHT-h)/2;
   if ((grf2=create_grafik(w>h?w:h,h>w?h:w))==NULL) {end_err("Intro","Create graphic");}
   if ((grf3=create_grafik(w,h))==NULL) {end_err("Intro","Create graphic");}
   for (i1=-180,f1=.01;i1<=720;i1+=30,f1+=.033) {
     x=y=w=h=0;
     if (zoom_grafik(grf2,grf1,f1,f1,&x,&y,&w,&h)==NULL) {end_err("Intro","Zoom graphic");}
     copy_grafik(grf3,x,y,grf2,0,0,w,h,RGB_FULL);
     x=y=w=h=0;
     if (rotate_grafik(grf2,grf3,i1%360,&x,&y,&w,&h)==NULL) {end_err("Intro","Rotate graphic");}
     CLEAR_BOX(NULL,col);
     copy_grafik(NULL,posx+x,posy+y,grf2,0,0,w,h,RGB_TRANS);
     flush_window();
     wait_time(60);
   }
   sleep(1);
   for (;posy>=5;posy-=2) {
     CLEAR_BOX(NULL,col);
     copy_grafik(NULL,posx,posy,grf2,0,0,0,0,RGB_TRANS);
     flush_window();
     wait_time(10);
   }
   posy+=GRAFIK_HEIGHT(grf1)+30;
   free_grafik(grf3);
   free_grafik(grf2);
   free_grafik(grf1);
#if !defined(SPRACHE) || SPRACHE <= 1
   snprintf(buf,sizeof(buf),"%s/film/vor1_de.vga",INST_PFAD);
#elif SPRACHE == 2
   snprintf(buf,sizeof(buf),"%s/film/vor1_en.vga",INST_PFAD);
#endif
   ptr=strstr(buf,"vor1")+3;
   for (x=0;*ptr<='5';(*ptr)++) {
     if ((grf1=load_grafik(buf))==NULL) {end_err("Intro","Load graphic");}
     posx=(SC_WIDTH-GRAFIK_WIDTH(grf1))/2;
     for (i1=-GRAFIK_WIDTH(grf1);i1<=posx;i1+=3) {
       draw_fillbox(NULL,0,posy,SC_WIDTH,posy+GRAFIK_HEIGHT(grf1),col);
       copy_grafik(NULL,i1,posy,grf1,0,0,0,0,RGB_TRANS);
       flush_window();
       wait_time(10);
       get_keys();
       if ((IS_KEYS(KEY_Q)) || (IS_KEYS(KEY_ENTER)) || (IS_KEYS(KEY_SPACE))) {x=1; break;}
     }
     if (x==1) {break;}
     if (*ptr=='4') {y=80;} else {y=40;}
     for (;y>0;y--) {
       wait_time(50);
       get_keys();
       if ((IS_KEYS(KEY_Q)) || (IS_KEYS(KEY_ENTER)) || (IS_KEYS(KEY_SPACE))) {x=1; break;}
     }
     if (x==1) {break;}
     for (;i1<=SC_WIDTH;i1+=3) {
       draw_fillbox(NULL,0,posy,SC_WIDTH,posy+GRAFIK_HEIGHT(grf1),col);
       copy_grafik(NULL,i1,posy,grf1,0,0,0,0,RGB_TRANS);
       flush_window();
       wait_time(10);
       get_keys();
       if ((IS_KEYS(KEY_Q)) || (IS_KEYS(KEY_ENTER)) || (IS_KEYS(KEY_SPACE))) {x=1; break;}
     }
     if (x==1) {break;}
     free_grafik(grf1);
   }
   if (x==1) {free_grafik(grf1);}
  }

  /* +++ Intro-Film erstellen +++ */
  if ((flm=create_film(7))==NULL) {return;}
  SET_FILM(flm,1,0,0,_intro_film);
  /* 1. Sequenz: Schlange */
  snprintf(buf,sizeof(buf),"%s/film/i_1.vga",INST_PFAD);
  SET_FILM_BILD(&bld,load_grafik(buf),0,0,RGB_FULL,100,0,0,0);
  add_bild_to_film(flm,&bld,1);
  /* 2. Sequenz: Augen */
  SET_FILM_BILD(&bld,NULL,49,12,RGB_FULL,88,0,0,0);
  add_bild_to_film(flm,&bld,2);
  snprintf(buf,sizeof(buf),"%s/film/i_2.vga",INST_PFAD);
  SET_FILM_BILD(&bld,load_grafik(buf),49,12,RGB_FULL,5,0,0,0);
  add_bild_to_film(flm,&bld,2);
  /* 3. Sequenz: Mund */
  SET_FILM_BILD(&bld,NULL,63,52,RGB_FULL,2,0,0,0);
  add_bild_to_film(flm,&bld,3);
  snprintf(buf,sizeof(buf),"%s/film/i_3.vga",INST_PFAD);
  SET_FILM_BILD(&bld,load_grafik(buf),63,52,RGB_FULL,3,0,0,0);
  add_bild_to_film(flm,&bld,3);
  /* 4. Sequenz: Zunge */
  snprintf(buf,sizeof(buf),"%s/film/i_4.vga",INST_PFAD);
  SET_FILM_BILD(&bld,load_grafik(buf),36,57,RGB_TRANS,78,0,0,0);
  add_bild_to_film(flm,&bld,4);
  snprintf(buf,sizeof(buf),"%s/film/i_5.vga",INST_PFAD);
  SET_FILM_BILD(&bld,load_grafik(buf),82,57,RGB_TRANS,113,0,0,0);
  add_bild_to_film(flm,&bld,4);
  /* 5. Sequenz: Pfeife */
  snprintf(buf,sizeof(buf),"%s/film/i_6.vga",INST_PFAD);
  SET_FILM_BILD(&bld,load_grafik(buf),103,48,RGB_TRANS,100,0,0,0);
  add_bild_to_film(flm,&bld,5);
  /* 6. Sequenz: Pfeifenrauch */
  snprintf(buf,sizeof(buf),"%s/film/i_7.vga",INST_PFAD);
  SET_FILM_BILD(&bld,load_grafik(buf),136,1,RGB_TRANS,26,0,0,0);
  add_bild_to_film(flm,&bld,6);
  snprintf(buf,sizeof(buf),"%s/film/i_8.vga",INST_PFAD);
  SET_FILM_BILD(&bld,load_grafik(buf),132,3,RGB_TRANS,33,0,0,0);
  add_bild_to_film(flm,&bld,6);
  /* 7. Sequenz: Text */
#if !defined(SPRACHE) || SPRACHE <= 1
  snprintf(buf,sizeof(buf),"%s/film/i_t1_de.vga",INST_PFAD);
#elif SPRACHE == 2
  snprintf(buf,sizeof(buf),"%s/film/i_t1_en.vga",INST_PFAD);
#endif
  ptr=strstr(buf,"i_t1")+3;
  SET_FILM_BILD(&bld,load_grafik(buf),170,15,RGB_TRANS,200,0,0,0);
  add_bild_to_film(flm,&bld,7);
  *ptr='2';
  SET_FILM_BILD(&bld,load_grafik(buf),170,15,RGB_TRANS,200,0,0,0);
  add_bild_to_film(flm,&bld,7);
  *ptr='3';
  SET_FILM_BILD(&bld,load_grafik(buf),170,15,RGB_TRANS,200,0,0,0);
  add_bild_to_film(flm,&bld,7);
  *ptr='4';
  SET_FILM_BILD(&bld,load_grafik(buf),170,15,RGB_TRANS,200,0,0,0);
  add_bild_to_film(flm,&bld,7);
  *ptr='5';
  SET_FILM_BILD(&bld,load_grafik(buf),170,15,RGB_TRANS,200,0,0,0);
  add_bild_to_film(flm,&bld,7);
  *ptr='6';
  SET_FILM_BILD(&bld,load_grafik(buf),170,15,RGB_TRANS,210,0,0,0);
  add_bild_to_film(flm,&bld,7);

  /* +++ Intro-Film zeigen +++ */
  play_wave(MUS_INTRO,cnn[0],0,0);
  CLEAR_BOX(NULL,RGB_BLACK);
  flush_window();
  sleep(3);
  reset_film(flm,NULL,1);
  do {
    CLEAR_BOX(NULL,RGB_BLACK);
    l1=copy_film(NULL,flm,NULL);
    flush_window();
    wait_time(40);
    get_keys();
    if ((IS_KEYS(KEY_Q)) || (IS_KEYS(KEY_ENTER)) || (IS_KEYS(KEY_SPACE))) {break;}
  } while (l1<1300L);
  for (i1=0;i1>=-63;i1--) {
    brightness(i1);
    flush_window();
    wait_time(70);
  }
  CLEAR_BOX(NULL,RGB_BLACK);
  flush_window();
  brightness(0);
  free_film(flm);
  stop_wave(cnn[0],3);
} /* Ende intro */


char * game() {
  const int rerand=50;  /* Pixel rechter Rand */
  const int hlx0=4;  /* Freiraeume zwischen Mauern (X-Richtung) */
  const int hlx1=6;  /* Mauernanzahl (X-Richtung) */
  const int hly0=3;  /* Freiraeume zwischen Mauern (Y-Richtung) */
  const int hly1=5;  /* Mauernanzahl (Y-Richtung) */
  const int hlz=16;  /* Zusatz-Verbindungsmauern */
  ebene _eb1;
  grafik * grf1,* grf2,* grf_maske,* hoehle_maske;
  size_t s1;
  FILE * fpeb,* fsav;
  char buf[1024];
  int hoehle_w=hlx0*(hlx1+1)+hlx1+2,hoehle_h=hly0*(hly1+1)+hly1+2;
  int hoehle[hoehle_w][hoehle_h],ebnr;
  int i1,i2,i3,i4,i5,i6,ii;
  int start_x,start_y,pix_x,pix_y;
  int frisst_en,frisst_zhl,erg,e_aktiv,game_erg;
  int punkte,fsanz[ES_ANZ],fswarte;

  /* +++ Initialisierungen +++ */
  setze_keys(0);
  punkte=0;
  ebnr=0;
  sn_i.glied_max=8;
  sn_i.glied_mom=sn_i.glied_max;
  ebn.hell=0;
  ebn.freib=0;
  ebn.mauer=0;
  game_erg=1;
  grf_maske=NULL;
  if (gamelevel==3) {
    if ((fsav=fopen(INST_PFAD"/save/savegame","r"))!=NULL) {
      fscanf(fsav,"%d %d %d %d",&ebnr,&punkte,&sn_i.glied_mom,&gamelevel);
      fclose(fsav);
    } else {gamelevel=0;}
  } else {
    if ((fsav=fopen(INST_PFAD"/save/savegame","w"))!=NULL) {
      fprintf(fsav,"%d %d %d %d",ebnr,punkte,sn_i.glied_mom,gamelevel);
      fchmod(fileno(fsav),0666);
      fclose(fsav);
    }
  }

  if (gamelevel==1) {
    if ((fpeb=fopen(INST_PFAD"/data/game_1.data","r"))==NULL) {
      return("Cannot read data/game_1.data");
    }
  } else if (gamelevel==2) {
    if ((fpeb=fopen(INST_PFAD"/data/game_2.data","r"))==NULL) {
      return("Cannot read data/game_2.data");
    }
  } else {return("game.data?");}
  CLEAR_BOX(NULL,RGB_BLACK);
  set_font(font10x17,10,17);
#if !defined(SPRACHE) || SPRACHE <= 1
  draw_text(NULL,color_index(CL_YELLOW,100),70,60,"     Lade ...",13,RGB_FULL);
  draw_text(NULL,color_index(CL_YELLOW,100),70,90,"[Q]      - Beenden",18,RGB_FULL);
  draw_text(NULL,color_index(CL_YELLOW,100),70,110,"[RETURN] - Men",15,RGB_FULL);
#elif SPRACHE == 2
  draw_text(NULL,color_index(CL_YELLOW,100),70,60,"    Get ready",13,RGB_FULL);
  draw_text(NULL,color_index(CL_YELLOW,100),70,90," [Q]      - Quit",16,RGB_FULL);
  draw_text(NULL,color_index(CL_YELLOW,100),70,110," [RETURN] - Menu",16,RGB_FULL);
#endif
  set_font(NULL,0,0);
  flush_window();
  sleep(4);

  /* +++ Ebenen laden +++ */
  zw_seq(ebnr);
  for (i1=0;i1<ebnr;i1++) {fread(&_eb1,sizeof(_eb1),1,fpeb);}
  while ((s1=fread(&_eb1,sizeof(_eb1),1,fpeb))==1) {  /* naechste Ebene */
    ebnr++;
    _eb1.u.hoehle=NULL;
    if (_eb1.hell!=ebn.hell) {  /* andere Helligkeit */
      brightness(_eb1.hell);
    }
    if (_eb1.en_max>EB_EN_MAX) {_eb1.en_max=EB_EN_MAX;}
    _eb1.en_mom=0;
    if (_eb1.en_anz<=0) {_eb1.en_anz=1;} else if (_eb1.en_anz>=10) {_eb1.en_anz=10;}
    memmove(&ebn,&_eb1,sizeof(ebene));

    /* +++ Hoehle erstellen +++ */
    /* Einzelgrafiken laden und zurechtstutzen */
    snprintf(buf,sizeof(buf),"%s/vga/freib%d.vga",INST_PFAD,ebn.freib);
    if ((grf1=load_grafik(buf))==NULL) {fclose(fpeb); return("Loading graphic");}
    snprintf(buf,sizeof(buf),"%s/vga/mauer%d.vga",INST_PFAD,ebn.mauer);
    if ((grf2=load_grafik(buf))==NULL) {fclose(fpeb); return("Loading graphic");}
    pix_x=(GRAFIK_WIDTH(grf1)<GRAFIK_WIDTH(grf2)?GRAFIK_WIDTH(grf1):GRAFIK_WIDTH(grf2));
    pix_y=(GRAFIK_HEIGHT(grf1)<GRAFIK_HEIGHT(grf2)?GRAFIK_HEIGHT(grf1):GRAFIK_HEIGHT(grf2));
    if (hoehle_w*pix_x>SC_WIDTH-rerand) {pix_x-=((hoehle_w*pix_x-(SC_WIDTH-rerand))/hoehle_w+1);}
    if (hoehle_h*pix_y>SC_HEIGHT) {pix_y-=((hoehle_h*pix_y-SC_HEIGHT)/hoehle_h+1);}
    if ((pix_x<1) || (pix_y<1)) {fclose(fpeb); return("Graphic too small");}
    if ((ebn.u.hoehle=create_grafik(hoehle_w*pix_x,hoehle_h*pix_y))==NULL) {fclose(fpeb); return("Create graphic");}
    if ((grf_maske=create_grafik(pix_x,pix_y))==NULL) {fclose(fpeb); return("Create graphic");}
    CLEAR_BOX(grf_maske,RGB_WHITE);
    if ((hoehle_maske=create_grafik(hoehle_w*pix_x,hoehle_h*pix_y))==NULL) {fclose(fpeb); return("Create graphic");}
    CLEAR_BOX(hoehle_maske,RGB_BLACK);

    /* Startkoordinaten Hoehle */
    start_x=(SC_WIDTH-rerand-hoehle_w*pix_x)/2;
    start_y=(SC_HEIGHT-hoehle_h*pix_y)/2;

    /* Mauern setzen */
    memset(hoehle,0,sizeof(hoehle));
    for (i1=1;i1<hlx1+1;i1++) {
      for (i2=1;i2<hly1+1;i2++) {
        hoehle[i1*(hlx0+1)][i2*(hly0+1)]=1;  /* Mauern */
      }
    }
    for (i1=0;i1<hoehle_w;i1++) {
      hoehle[i1][0]=1;  /* Begrenzungsmauern */
      hoehle[i1][(hly1+1)*(hly0+1)]=1;  /* Begrenzungsmauern */
    }
    for (i2=0;i2<hoehle_h;i2++) {
      hoehle[0][i2]=1;  /* Begrenzungsmauern */
      hoehle[(hlx1+1)*(hlx0+1)][i2]=1;  /* Begrenzungsmauern */
    }
    for (i1=0;i1<hlz/2;i1++) {
      i2=ZUFALL((hlx1-1)*hly1);
      i3=hlx0+1+(i2%(hlx1-1))*(hlx0+1)+1;
      i4=hly0+1+(i2/(hlx1-1))*(hly0+1);
      i5=i3+hlx0;
      while (i3<i5) {hoehle[i3++][i4]=1;}
    }
    for (i1=0;i1<hlz/2;i1++) {
      i2=ZUFALL((hly1-1)*hlx1);
      i3=hly0+1+(i2%(hly1-1))*(hly0+1)+1;
      i4=hlx0+1+(i2/(hly1-1))*(hlx0+1);
      i5=i3+hly0;
      while (i3<i5) {hoehle[i4][i3++]=1;}
    }

    /* Hoehle zeichnen */
    for (i1=0;i1<hoehle_w;i1++) {
      for (i2=0;i2<hoehle_h;i2++) {
        if (hoehle[i1][i2]==1) {  /* Mauer */
          copy_grafik(ebn.u.hoehle,i1*pix_x,i2*pix_y,grf1,0,0,pix_x,pix_y,RGB_FULL);
          copy_grafik(ebn.u.hoehle,i1*pix_x,i2*pix_y,grf2,0,0,pix_x,pix_y,RGB_TRANS);
          copy_grafik(hoehle_maske,i1*pix_x,i2*pix_y,grf_maske,0,0,pix_x,pix_y,RGB_FULL);
        } else {
          copy_grafik(ebn.u.hoehle,i1*pix_x,i2*pix_y,grf1,0,0,pix_x,pix_y,RGB_FULL);
        }
      }
    }
    free_grafik(grf1);
    free_grafik(grf2);

    /* +++ Schlangen und Extras setzen +++ */
    /* eigene Schlange setzen */
    sn_i.x=pix_x+ikopf;
    sn_i.y=(hoehle_h/2)*pix_y+ikopf;
    sn_i.z=0;
    for (i1=0;i1<i_stream;i1++) {
      i_streamx[i1]=(short)sn_i.x;
      i_streamy[i1]=(short)sn_i.y;
      i_streamz[i1]=(short)sn_i.z;
    }
    sn_i.xyz_pos[0]=ikopf+iglied-1;
    for (i1=1;i1<MAXIMAL_GLIED;i1++) {
      sn_i.xyz_pos[i1]=sn_i.xyz_pos[i1-1]+iglied*2;
    }
    sn_i.xdez=sn_i.ydez=0;
    sn_i.gift_taste=0;
    sn_i.tarnkappe=0;
    memset(sn_i.gift,0,sizeof(sn_i.gift));

    /* Feind-Schlangen setzen */
    for (i1=0;i1<ebn.en_max;i1++) {
      if (ebn.gattung[i1]>=ES_ANZ) {ebn.gattung[i1]=0;}
      sn_e[i1].aktiv=2;
      sn_e[i1].gattung=ebn.gattung[i1];
      if (enemy_art[sn_e[i1].gattung].gift_anz>EN_GIFT_MAX) {enemy_art[sn_e[i1].gattung].gift_anz=EN_GIFT_MAX;}
      sn_e[i1].glied_mom=enemy_art[sn_e[i1].gattung].glied_max;
      sn_e[i1].x=sn_e[i1].y=sn_e[i1].z=0;
      sn_e[i1].xyz_pos[0]=ekopf+eglied[sn_e[i1].gattung]-1;
      for (i2=1;i2<MAXIMAL_GLIED;i2++) {
        sn_e[i1].xyz_pos[i2]=sn_e[i1].xyz_pos[i2-1]+eglied[sn_e[i1].gattung]*2;
      }
      sn_e[i1].xplus=sn_e[i1].xdez=sn_e[i1].yplus=sn_e[i1].ydez=0;
      sn_e[i1].xynoch=sn_e[i1].gzhl=sn_e[i1].tarnkappe=0;
      memset(sn_e[i1].gift,0,sizeof(sn_e[i1].gift));
      /* Startposition */
      switch (ZUFALL(4)) {
        case 0:
          sn_e[i1].x=pix_x+ekopf;
          sn_e[i1].y=pix_y+ekopf;
          break;
        case 1:
          sn_e[i1].x=(hoehle_w-1)*pix_x-ekopf-1;
          sn_e[i1].y=pix_y+ekopf;
          break;
        case 2:
          sn_e[i1].x=pix_x+ekopf;
          sn_e[i1].y=(hoehle_h-1)*pix_y-ekopf-1;
          break;
        case 3:
          sn_e[i1].x=(hoehle_w-1)*pix_x-ekopf-1;
          sn_e[i1].y=(hoehle_h-1)*pix_y-ekopf-1;
          break;
      }
      for (i2=0;i2<e_stream;i2++) {
        e_streamx[i1][i2]=(short)sn_e[i1].x;
        e_streamy[i1][i2]=(short)sn_e[i1].y;
        e_streamz[i1][i2]=(short)sn_e[i1].z;
      }
    }

    /* Extras setzen */
    giftfl.aktiv=0;
    ebn.giftfl_zhl=ebn.giftfl_weg;
    tarnkp.aktiv=0;
    ebn.tarnkp_zhl=ebn.tarnkp_weg;

    /* +++ Gameloop +++ */
    frisst_en=-1;
    frisst_zhl=0;
    game_erg=0;
    play_wave(MUS_NR(ebn.musnr),cnn[0],1,0);
    wait_time(0);
    while (1) {
      get_keys();

      /* allgemeine Eingaben */
      if (IS_KEYS(KEY_Q)) {break;}  /* quit */
      if (IS_KEYS(KEY_F2)) {  /* screenshot as ppm */
        save_grafik_as_ppm(NULL,"/tmp/_vgag_bs.ppm");
      }
      if (IS_KEYS(KEY_P)) {  /* Pause */
        pause_wave(CN_ALL);
        set_font(font10x17,10,17);
        draw_text(NULL,color_index(CL_GREEN,100),start_x+hoehle_w*pix_x/2-5*10/2,start_y+hoehle_h*pix_y/2-17/2,"PAUSE",5,RGB_FULL);
        set_font(NULL,0,0);
        flush_window();
        do {
          wait_time(150);
          get_keys();
          if (IS_KEYS(KEY_Q)) {break;}  /* quit */
        } while (IS_KEYS(KEY_P)==0);
        if (IS_KEYS(KEY_Q)) {break;}  /* quit */
        continue_wave(CN_ALL);
      }
      if (IS_KEYS(KEY_ENTER)) {brightness(0); menu(1); brightness(ebn.hell);}  /* Menu */

      CLEAR_BOX(NULL,RGB_BLACK);
      copy_grafik(NULL,start_x,start_y,ebn.u.hoehle,0,0,0,0,RGB_FULL);

      /* eigene Schlange */
      if (frisst_en<0) {
        if (IS_KEYS(KEY_LCTRL)) {  /* Giftschuss */
          if (sn_i.gift_taste==0) {
            for (i1=0;i1<IS_GIFT_MAX;i1++) {
              if (sn_i.gift[i1].aktiv==0) {
                sn_i.gift[i1].x=sn_i.x;
                sn_i.gift[i1].y=sn_i.y;
                sn_i.gift[i1].xdez=sn_i.gift[i1].ydez=0;
                switch (sn_i.z) {  /* Kopfschaurichtung */
                  case 0:  sn_i.gift[i1].xplus=IS_XYPLUS*GIFT_GESCHWPROZ/100;
                           if (sn_i.gift[i1].xplus>GIFT_PIXELMAX) {sn_i.gift[i1].xplus=GIFT_PIXELMAX;}
                           sn_i.gift[i1].yplus=0;
                           sn_i.gift[i1].x++;
                           sn_i.gift[i1].w=giftx/2;
                           sn_i.gift[i1].h=gifty/2;
                           sn_i.gift[i1].grg=i_gifth;
                           break;
                  case 1:  sn_i.gift[i1].xplus=0;
                           sn_i.gift[i1].yplus=IS_XYPLUS*GIFT_GESCHWPROZ/100;
                           if (sn_i.gift[i1].yplus>GIFT_PIXELMAX) {sn_i.gift[i1].yplus=GIFT_PIXELMAX;}
                           sn_i.gift[i1].y++;
                           sn_i.gift[i1].w=gifty/2;
                           sn_i.gift[i1].h=giftx/2;
                           sn_i.gift[i1].grg=i_giftv;
                           break;
                  case 2:  sn_i.gift[i1].xplus=-IS_XYPLUS*GIFT_GESCHWPROZ/100;
                           if (sn_i.gift[i1].xplus<-GIFT_PIXELMAX) {sn_i.gift[i1].xplus=-GIFT_PIXELMAX;}
                           sn_i.gift[i1].yplus=0;
                           sn_i.gift[i1].x--;
                           sn_i.gift[i1].w=giftx/2;
                           sn_i.gift[i1].h=gifty/2;
                           sn_i.gift[i1].grg=i_gifth;
                           break;
                  case 3:  sn_i.gift[i1].xplus=0;
                           sn_i.gift[i1].yplus=-IS_XYPLUS*GIFT_GESCHWPROZ/100;
                           if (sn_i.gift[i1].yplus<-GIFT_PIXELMAX) {sn_i.gift[i1].yplus=-GIFT_PIXELMAX;}
                           sn_i.gift[i1].y--;
                           sn_i.gift[i1].w=gifty/2;
                           sn_i.gift[i1].h=giftx/2;
                           sn_i.gift[i1].grg=i_giftv;
                           break;
                }
                sn_i.gift[i1].aktiv=1;
                sn_i.gift_taste=40000*giftx/(IS_XYPLUS*GIFT_GESCHWPROZ);
                play_wave(SND_I_GIFTSPRITZEN,cnn[1],0,0);
                break;
              }
            }
          } else {sn_i.gift_taste--;}
        } else {
          if (--sn_i.gift_taste<0) {sn_i.gift_taste=0;}
          erg=0;
          if ((IS_KEYS(KEY_RCURS)) || (IS_KEYS(KEY_KP_6))) {  /* rechts kriechen */
            i2=sn_i.x; i3=sn_i.y;
            i4=sn_i.xdez; i5=sn_i.ydez;
            i4+=IS_XYPLUS; i2+=i4/100; i4-=i4/100*100;
            if (!AN_ECKEN(i2,i3,ikopf,ikopf)) {
              if (i2!=sn_i.x) {I_STREAM_MOVE;}
              sn_i.x=i2; sn_i.y=i3; sn_i.z=0;
              sn_i.xdez=i4; sn_i.ydez=i5;
              erg=1;
            }
          }
          if ((IS_KEYS(KEY_LCURS)) || (IS_KEYS(KEY_KP_4))) {  /* links kriechen */
            i2=sn_i.x; i3=sn_i.y;
            i4=sn_i.xdez; i5=sn_i.ydez;
            i4-=IS_XYPLUS; i2+=i4/100; i4-=i4/100*100;
            if (!AN_ECKEN(i2,i3,ikopf,ikopf)) {
              if (i2!=sn_i.x) {I_STREAM_MOVE;}
              sn_i.x=i2; sn_i.y=i3; sn_i.z=2;
              sn_i.xdez=i4; sn_i.ydez=i5;
              erg=1;
            }
          }
          if (erg==0) {  /* nicht diagonal kriechen */
            if ((IS_KEYS(KEY_UCURS)) || (IS_KEYS(KEY_KP_8))) {  /* rauf kriechen */
              i2=sn_i.x; i3=sn_i.y;
              i4=sn_i.xdez; i5=sn_i.ydez;
              i5-=IS_XYPLUS; i3+=i5/100; i5-=i5/100*100;
              if (!AN_ECKEN(i2,i3,ikopf,ikopf)) {
                if (i3!=sn_i.y) {I_STREAM_MOVE;}
                sn_i.x=i2; sn_i.y=i3; sn_i.z=3;
                sn_i.xdez=i4; sn_i.ydez=i5;
              }
            }
            if ((IS_KEYS(KEY_DCURS)) || (IS_KEYS(KEY_KP_2))) {  /* runter kriechen */
              i2=sn_i.x; i3=sn_i.y;
              i4=sn_i.xdez; i5=sn_i.ydez;
              i5+=IS_XYPLUS; i3+=i5/100; i5-=i5/100*100;
              if (!AN_ECKEN(i2,i3,ikopf,ikopf)) {
                if (i3!=sn_i.y) {I_STREAM_MOVE;}
                sn_i.x=i2; sn_i.y=i3; sn_i.z=1;
                sn_i.xdez=i4; sn_i.ydez=i5;
              }
            }
          }
        }
      } else {
        if (--frisst_zhl==0) {sn_e[frisst_en].aktiv=0; frisst_en=-1;}
        else {sn_e[frisst_en].glied_mom=frisst_zhl/10+1;}
      }

      /* Heraustritt weiterer Feindschlange? */
      if (ebn.en_mom<ebn.en_max) {
        if (--ebn.warte_max[ebn.en_mom]<=0) {
          sn_e[ebn.en_mom].aktiv=1;
          ebn.en_mom++;
          play_wave(SND_E_KOMMT,cnn[2],0,0);
        } else if (ebn.warte_max[ebn.en_mom]<60) {
          i1=(30-ebn.warte_max[ebn.en_mom]%30)/3+1;
          draw_fillbox(NULL,start_x+sn_e[ebn.en_mom].x-i1/2,start_y+sn_e[ebn.en_mom].y-i1/2,i1,i1,RGB_BLACK);
        }
      }

      /* Feindschlangen */
      e_aktiv=fswarte=0;
      memset(fsanz,0,sizeof(fsanz));
      for (i1=0;i1<ebn.en_max;i1++) {
        if (sn_e[i1].aktiv!=1) {
          if (sn_e[i1].aktiv==2) {fswarte++;}
          continue;
        }
        e_aktiv++;
        fsanz[sn_e[i1].gattung]++;
        if (i1!=frisst_en) {TESTE_ESNAKE(i1,erg);} else {erg=1;}
        if (erg==0) {
          if (--sn_e[i1].gzhl<0) {sn_e[i1].gzhl=0;}
          /* Giftschuss? */
          if (ZUFALL(30+sn_e[i1].gzhl*5)<=2) {
            for (i2=0;i2<EN_GIFT_MAX;i2++) {
              if (sn_e[i1].gift[i2].aktiv==0) {
                erg=1;
                sn_e[i1].gzhl=100/enemy_art[sn_e[i1].gattung].gift_anz;
                sn_e[i1].gift[i2].x=sn_e[i1].x;
                sn_e[i1].gift[i2].y=sn_e[i1].y;
                sn_e[i1].gift[i2].xdez=sn_e[i1].gift[i2].ydez=0;
                sn_e[i1].gift[i2].zhl=0;
                switch (sn_e[i1].z) {  /* Kopfschaurichtung */
                  case 0:  sn_e[i1].gift[i2].xplus=enemy_art[sn_e[i1].gattung].xyplus*GIFT_GESCHWPROZ/100;
                           if (sn_e[i1].gift[i2].xplus>GIFT_PIXELMAX) {sn_e[i1].gift[i2].xplus=GIFT_PIXELMAX;}
                           sn_e[i1].gift[i2].yplus=0;
                           sn_e[i1].gift[i2].x++;
                           sn_e[i1].gift[i2].w=giftx/2;
                           sn_e[i1].gift[i2].h=gifty/2;
                           sn_e[i1].gift[i2].grg[0]=e_gifth1[enemy_art[sn_e[i1].gattung].gift_stark-1];
                           sn_e[i1].gift[i2].grg[1]=e_gifth2[enemy_art[sn_e[i1].gattung].gift_stark-1];
                           break;
                  case 1:  sn_e[i1].gift[i2].xplus=0;
                           sn_e[i1].gift[i2].yplus=enemy_art[sn_e[i1].gattung].xyplus*GIFT_GESCHWPROZ/100;
                           if (sn_e[i1].gift[i2].yplus>GIFT_PIXELMAX) {sn_e[i1].gift[i2].yplus=GIFT_PIXELMAX;}
                           sn_e[i1].gift[i2].y++;
                           sn_e[i1].gift[i2].w=gifty/2;
                           sn_e[i1].gift[i2].h=giftx/2;
                           sn_e[i1].gift[i2].grg[0]=e_giftv1[enemy_art[sn_e[i1].gattung].gift_stark-1];
                           sn_e[i1].gift[i2].grg[1]=e_giftv2[enemy_art[sn_e[i1].gattung].gift_stark-1];
                           break;
                  case 2:  sn_e[i1].gift[i2].xplus=-enemy_art[sn_e[i1].gattung].xyplus*GIFT_GESCHWPROZ/100;
                           if (sn_e[i1].gift[i2].xplus<-GIFT_PIXELMAX) {sn_e[i1].gift[i2].xplus=-GIFT_PIXELMAX;}
                           sn_e[i1].gift[i2].yplus=0;
                           sn_e[i1].gift[i2].x--;
                           sn_e[i1].gift[i2].w=giftx/2;
                           sn_e[i1].gift[i2].h=gifty/2;
                           sn_e[i1].gift[i2].grg[0]=e_gifth1[enemy_art[sn_e[i1].gattung].gift_stark-1];
                           sn_e[i1].gift[i2].grg[1]=e_gifth2[enemy_art[sn_e[i1].gattung].gift_stark-1];
                           break;
                  case 3:  sn_e[i1].gift[i2].xplus=0;
                           sn_e[i1].gift[i2].yplus=-enemy_art[sn_e[i1].gattung].xyplus*GIFT_GESCHWPROZ/100;
                           if (sn_e[i1].gift[i2].yplus<-GIFT_PIXELMAX) {sn_e[i1].gift[i2].yplus=-GIFT_PIXELMAX;}
                           sn_e[i1].gift[i2].y--;
                           sn_e[i1].gift[i2].w=gifty/2;
                           sn_e[i1].gift[i2].h=giftx/2;
                           sn_e[i1].gift[i2].grg[0]=e_giftv1[enemy_art[sn_e[i1].gattung].gift_stark-1];
                           sn_e[i1].gift[i2].grg[1]=e_giftv2[enemy_art[sn_e[i1].gattung].gift_stark-1];
                           break;
                }
                sn_e[i1].gift[i2].aktiv=1;
                break;
              }
            }
          }
        }
        if (erg!=1) {  /* kein Giftschuss und nicht gefressen */
          /* Bewegung */
          if (erg>=10) {sn_e[i1].xynoch=1;}
          if (--sn_e[i1].xynoch<=0) {
            if (erg>=10) {
              i2=erg-10;
            } else {
              i2=ZUFALL(3)+sn_e[i1].z-1;
              if (i2==-1) {i2=3;} else if (i2==4) {i2=0;}
            }
            switch (i2) {
              case 0:
                sn_e[i1].xplus=enemy_art[sn_e[i1].gattung].xyplus;
                sn_e[i1].yplus=0;
                break;
              case 1:
                sn_e[i1].xplus=0;
                sn_e[i1].yplus=enemy_art[sn_e[i1].gattung].xyplus;
                break;
              case 2:
                sn_e[i1].xplus=-enemy_art[sn_e[i1].gattung].xyplus;
                sn_e[i1].yplus=0;
                break;
              case 3:
                sn_e[i1].xplus=0;
                sn_e[i1].yplus=-enemy_art[sn_e[i1].gattung].xyplus;
                break;
            }
            sn_e[i1].z=i2;
            sn_e[i1].xynoch=ZUFALL(100)+2;
            sn_e[i1].xdez=sn_e[i1].ydez=0;
          }
          i2=sn_e[i1].x; i3=sn_e[i1].y;
          i4=sn_e[i1].xdez; i5=sn_e[i1].ydez;
          i4+=sn_e[i1].xplus; i2+=i4/100; i4-=i4/100*100;
          i5+=sn_e[i1].yplus; i3+=i5/100; i5-=i5/100*100;
          if (!AN_ECKEN(i2,i3,ekopf,ekopf)) {
            if ((i2!=sn_e[i1].x) || (i3!=sn_e[i1].y)) {E_STREAM_MOVE(i1);}
            sn_e[i1].x=i2; sn_e[i1].y=i3;
            sn_e[i1].xdez=i4; sn_e[i1].ydez=i5;
            TESTE_ESNAKE(i1,erg);
          } else {sn_e[i1].xynoch=0;}
        }
        /* Feindschlange malen */
        if (sn_e[i1].aktiv) {
          TESTE_EZUSATZ(i1);
          if (sn_e[i1].tarnkappe>0) {
            sn_e[i1].tarnkappe--;
            copy_grafik(NULL,start_x+sn_e[i1].x-zaugex,start_y+sn_e[i1].y-zaugey,auge[1],0,0,0,0,RGB_TRANS);
          } else {
            for (i6=sn_e[i1].glied_mom-1;i6>=0;i6--) {
              copy_grafik(NULL,start_x+e_streamx[i1][sn_e[i1].xyz_pos[i6]]-eglied[sn_e[i1].gattung],start_y+e_streamy[i1][sn_e[i1].xyz_pos[i6]]-eglied[sn_e[i1].gattung],enemy_art[sn_e[i1].gattung].glied[e_streamz[i1][sn_e[i1].xyz_pos[i6]]],0,0,0,0,RGB_TRANS);
            }
            if (sn_e[i1].glied_mom>sn_i.glied_mom) {
              copy_grafik(NULL,start_x+sn_e[i1].x-ekopf,start_y+sn_e[i1].y-ekopf,ge_oberkopf[sn_e[i1].z],0,0,0,0,RGB_TRANS);
            } else {
              copy_grafik(NULL,start_x+sn_e[i1].x-ekopf,start_y+sn_e[i1].y-ekopf,ge_kopf[sn_e[i1].z],0,0,0,0,RGB_TRANS);
            }
            if (ZUFALL(12)==1) {
              switch (sn_e[i1].z) {  /* Kopfschaurichtung */
                case 0:
                  copy_grafik(NULL,start_x+sn_e[i1].x+ekopf,start_y+sn_e[i1].y-1,zunge0,0,0,0,0,RGB_TRANS);
                  break;
                case 1:
                  copy_grafik(NULL,start_x+sn_e[i1].x-1,start_y+sn_e[i1].y+ekopf,zunge1,0,0,0,0,RGB_TRANS);
                  break;
                case 2:
                  copy_grafik(NULL,start_x+sn_e[i1].x-ekopf-4,start_y+sn_e[i1].y-1,zunge2,0,0,0,0,RGB_TRANS);
                  break;
                case 3:
                  copy_grafik(NULL,start_x+sn_e[i1].x-1,start_y+sn_e[i1].y-ekopf-4,zunge3,0,0,0,0,RGB_TRANS);
                  break;
              }
            }
          }
        }
      }

      /* zuwenig Feindschlangen aktiv? */
      if ((ebn.en_mom<ebn.en_max) && (e_aktiv<ebn.en_anz)) {
        if (ebn.warte_max[ebn.en_mom]>60) {ebn.warte_max[ebn.en_mom]=60;}
      }

      /* eigene Schlange malen */
      TESTE_IZUSATZ;
      if (sn_i.tarnkappe>0) {
        sn_i.tarnkappe--;
        copy_grafik(NULL,start_x+sn_i.x-zaugex,start_y+sn_i.y-zaugey,auge[0],0,0,0,0,RGB_TRANS);
        if ((sn_i.tarnkappe<100) && (sn_i.tarnkappe%20<5)) {
          for (i6=sn_i.glied_mom-1;i6>=0;i6--) {
            copy_grafik(NULL,start_x+i_streamx[sn_i.xyz_pos[i6]]-iglied,start_y+i_streamy[sn_i.xyz_pos[i6]]-iglied,gi_glied[i_streamz[sn_i.xyz_pos[i6]]],0,0,0,0,RGB_TRANS);
          }
        }
      } else {
        for (i6=sn_i.glied_mom-1;i6>=0;i6--) {
          copy_grafik(NULL,start_x+i_streamx[sn_i.xyz_pos[i6]]-iglied,start_y+i_streamy[sn_i.xyz_pos[i6]]-iglied,gi_glied[i_streamz[sn_i.xyz_pos[i6]]],0,0,0,0,RGB_TRANS);
        }
        copy_grafik(NULL,start_x+sn_i.x-ikopf,start_y+sn_i.y-ikopf,gi_kopf[sn_i.z],0,0,0,0,RGB_TRANS);
        if (ZUFALL(12)==1) {
          switch (sn_i.z) {  /* Kopfschaurichtung */
            case 0:
              copy_grafik(NULL,start_x+sn_i.x+ikopf,start_y+sn_i.y-1,zunge0,0,0,0,0,RGB_TRANS);
              break;
            case 1:
              copy_grafik(NULL,start_x+sn_i.x-1,start_y+sn_i.y+ikopf,zunge1,0,0,0,0,RGB_TRANS);
              break;
            case 2:
              copy_grafik(NULL,start_x+sn_i.x-ikopf-4,start_y+sn_i.y-1,zunge2,0,0,0,0,RGB_TRANS);
              break;
            case 3:
              copy_grafik(NULL,start_x+sn_i.x-1,start_y+sn_i.y-ikopf-4,zunge3,0,0,0,0,RGB_TRANS);
              break;
          }
        }
      }

      /* Feind-Giftschuesse */
      for (i1=0;i1<ebn.en_max;i1++) {
        for (ii=0;ii<enemy_art[sn_e[i1].gattung].gift_anz;ii++) {
          if (sn_e[i1].gift[ii].aktiv==0) {continue;}
          TESTE_EGIFT(i1,ii);
          if (sn_e[i1].gift[ii].aktiv==0) {continue;}
          i2=sn_e[i1].gift[ii].x; i3=sn_e[i1].gift[ii].y;
          i4=sn_e[i1].gift[ii].xdez; i5=sn_e[i1].gift[ii].ydez;
          i4+=sn_e[i1].gift[ii].xplus; i2+=i4/100; i4-=i4/100*100;
          i5+=sn_e[i1].gift[ii].yplus; i3+=i5/100; i5-=i5/100*100;
          if (++sn_e[i1].gift[ii].zhl>=10) {sn_e[i1].gift[ii].zhl=0;}
          if (!AN_ECKEN(i2,i3,sn_e[i1].gift[ii].w,sn_e[i1].gift[ii].h)) {
            sn_e[i1].gift[ii].x=i2; sn_e[i1].gift[ii].y=i3;
            sn_e[i1].gift[ii].xdez=i4; sn_e[i1].gift[ii].ydez=i5;
            copy_grafik(NULL,start_x+sn_e[i1].gift[ii].x-sn_e[i1].gift[ii].w,start_y+sn_e[i1].gift[ii].y-sn_e[i1].gift[ii].h,sn_e[i1].gift[ii].grg[sn_e[i1].gift[ii].zhl/5],0,0,0,0,RGB_TRANS);
            TESTE_EGIFT(i1,ii);
          } else {sn_e[i1].gift[ii].aktiv=0; sn_e[i1].gzhl=0;}
        }
      }

      /* eigene Giftschuesse */
      for (i1=0;i1<IS_GIFT_MAX;i1++) {
        if (sn_i.gift[i1].aktiv==0) {continue;}
        i2=sn_i.gift[i1].x; i3=sn_i.gift[i1].y;
        i4=sn_i.gift[i1].xdez; i5=sn_i.gift[i1].ydez;
        i4+=sn_i.gift[i1].xplus; i2+=i4/100; i4-=i4/100*100;
        i5+=sn_i.gift[i1].yplus; i3+=i5/100; i5-=i5/100*100;
        if (!AN_ECKEN(i2,i3,sn_i.gift[i1].w,sn_i.gift[i1].h)) {
          sn_i.gift[i1].x=i2; sn_i.gift[i1].y=i3;
          sn_i.gift[i1].xdez=i4; sn_i.gift[i1].ydez=i5;
          copy_grafik(NULL,start_x+sn_i.gift[i1].x-sn_i.gift[i1].w,start_y+sn_i.gift[i1].y-sn_i.gift[i1].h,sn_i.gift[i1].grg,0,0,0,0,RGB_TRANS);
        } else {sn_i.gift[i1].aktiv=0;}
      }

      /* Zusaetze */
      if (--ebn.giftfl_zhl<=0) {
        if (ebn.giftfl_max>0) {giftfl.aktiv=!giftfl.aktiv;} else {giftfl.aktiv=0;}
        if (giftfl.aktiv) {
          ebn.giftfl_zhl=ebn.giftfl_da;
          giftfl.graf_runde=0;
          i1=ZUFALL(hlx1+1)+1;
          i2=ZUFALL(hly1+1)+1;
          giftfl.x=(i1*(1+hlx0)-hlx0/2)*pix_x;
          giftfl.y=(i2*(1+hly0)-hly0/2)*pix_y;
          ebn.giftfl_max--;
        } else {ebn.giftfl_zhl=ebn.giftfl_weg;}
      }
      if (giftfl.aktiv) {
        if (++giftfl.graf_runde>=20) {giftfl.graf_runde=0;}
        copy_grafik(NULL,start_x+giftfl.x-zgiftflx,start_y+giftfl.y-zgiftfly,giftfl.bild[giftfl.graf_runde/10],0,0,0,0,RGB_TRANS);
      }
      if (--ebn.tarnkp_zhl<=0) {
        if (ebn.tarnkp_max>0) {tarnkp.aktiv=!tarnkp.aktiv;} else {tarnkp.aktiv=0;}
        if (tarnkp.aktiv) {
          ebn.tarnkp_zhl=ebn.tarnkp_da;
          tarnkp.graf_runde=0;
          i1=ZUFALL(hlx1+1)+1;
          i2=ZUFALL(hly1+1)+1;
          tarnkp.x=(i1*(1+hlx0)-hlx0/2)*pix_x;
          tarnkp.y=(i2*(1+hly0)-hly0/2)*pix_y;
          ebn.tarnkp_max--;
        } else {ebn.tarnkp_zhl=ebn.tarnkp_weg;}
      }
      if (tarnkp.aktiv) {
        if (++tarnkp.graf_runde>=20) {tarnkp.graf_runde=0;}
        copy_grafik(NULL,start_x+tarnkp.x-ztarnkpx,start_y+tarnkp.y-ztarnkpy,tarnkp.bild[tarnkp.graf_runde/10],0,0,0,0,RGB_TRANS);
      }

      /* Infofenster */
      draw_fillbox(NULL,SC_WIDTH-rerand,0,rerand,SC_HEIGHT,color_index(CL_VIOLET,30));
      draw_line(NULL,SC_WIDTH-rerand+2,2,SC_WIDTH-2,2,RGB_WHITE);
      draw_line(NULL,SC_WIDTH-rerand+5,5,SC_WIDTH-5,5,RGB_WHITE);
      draw_line(NULL,SC_WIDTH-rerand+5,SC_HEIGHT-5,SC_WIDTH-5,SC_HEIGHT-5,RGB_WHITE);
      draw_line(NULL,SC_WIDTH-rerand+2,SC_HEIGHT-2,SC_WIDTH-2,SC_HEIGHT-2,RGB_WHITE);
      draw_line(NULL,SC_WIDTH-rerand+2,2,SC_WIDTH-rerand+2,SC_HEIGHT-2,RGB_WHITE);
      draw_line(NULL,SC_WIDTH-rerand+5,5,SC_WIDTH-rerand+5,SC_HEIGHT-5,RGB_WHITE);
      draw_line(NULL,SC_WIDTH-5,5,SC_WIDTH-5,SC_HEIGHT-5,RGB_WHITE);
      draw_line(NULL,SC_WIDTH-2,2,SC_WIDTH-2,SC_HEIGHT-2,RGB_WHITE);
      i1=10;
      snprintf(buf,sizeof(buf),"%04d",punkte);
      draw_text(NULL,RGB_WHITE,SC_WIDTH-rerand+10,i1,buf,strlen(buf),RGB_TRANS);
      i1+=12;
      snprintf(buf,sizeof(buf),"%3d%%",sn_i.glied_mom*100/sn_i.glied_max);
      draw_text(NULL,color_index(CL_YELLOW,100),SC_WIDTH-rerand+10,i1,buf,strlen(buf),RGB_TRANS);
      i1+=12;
      draw_line(NULL,SC_WIDTH-rerand+15,i1,SC_WIDTH-15,i1,RGB_WHITE);
      i1+=4;
      snprintf(buf,sizeof(buf),"%+4d",fswarte);
      draw_text(NULL,color_index(CL_RED,100),SC_WIDTH-rerand+10,i1,buf,strlen(buf),RGB_TRANS);
      i1+=10;
      for (i2=0;i2<ES_ANZ;i2++) {
        copy_grafik(NULL,SC_WIDTH-rerand+10,i1,esymbol[i2],0,0,0,0,RGB_TRANS);
        i3=GRAFIK_HEIGHT(esymbol[i2]);
        snprintf(buf,sizeof(buf),"%d",fsanz[i2]);
        draw_text(NULL,color_index(CL_RED,100),SC_WIDTH-rerand+10+25,i1+i3/2-4,buf,strlen(buf),RGB_TRANS);
        i1+=i3+3;
      }
#if !defined(SPRACHE) || SPRACHE <= 1
      sprintf(buf,"%s Spiel: Ebene %d",gamelevel==1?"Leichtes":"Schweres",ebnr);
#elif SPRACHE == 2
      sprintf(buf,"%s game: level %d",gamelevel==1?"Easy":"Hard",ebnr);
#endif
      draw_text(NULL,color_index(CL_VIOLET,50),(SC_WIDTH-(strlen(buf)*8))/2,191,buf,strlen(buf),RGB_FULL);

      flush_window();
      wait_time(40);
      /* eigene Schlange k.o.? */
      if (sn_i.glied_mom<=0) {game_erg=-1; break;}
      /* Ebene fertig? */
      if ((ebn.en_mom>=ebn.en_max) && (e_aktiv==0)) {game_erg=1; break;}
    } /* Ende Gameloop */
    if (IS_KEYS(KEY_Q)) {brightness(0); break;}  /* quit */
    if (game_erg==-1) {  /* Game over */
      sleep(4);
      stop_wave(cnn[0],7);
      play_wave(SND_GAMEOVER,cnn[1],0,0);
      CLEAR_BOX(grf_maske,RGB_BLACK);
      for (ii=0;ii<250;ii++) {
        i1=ZUFALL(hoehle_w);
        i2=ZUFALL(hoehle_h);
        copy_grafik(NULL,start_x+i1*pix_x,start_y+i2*pix_y,grf_maske,0,0,pix_x,pix_y,RGB_FULL);
        flush_window();
        wait_time(30);
      }
      sleep(3);
      stop_wave(CN_ALL,0);
      CLEAR_BOX(NULL,RGB_BLACK);
      brightness(0);
      set_font(font10x17,10,17);
      draw_text(NULL,color_index(CL_YELLOW,100),SC_WIDTH/2-4*17,SC_HEIGHT/2-10/2,"Game over",9,RGB_FULL);
      set_font(NULL,0,0);
      flush_window();
      sleep(3);
      break;
    } else if (game_erg==1) {  /* Ebene fertig */
      stop_wave(CN_ALL,5);
      sleep(6);
      CLEAR_BOX(NULL,RGB_BLACK);
      brightness(0);
      zw_seq(ebnr);
    }
    stop_wave(CN_ALL,0);
    free_grafik(grf_maske);
    if ((fsav=fopen(INST_PFAD"/save/savegame","w"))!=NULL) {
      fprintf(fsav,"%d %d %d %d",ebnr,punkte,sn_i.glied_mom,gamelevel);
      fchmod(fileno(fsav),0666);
      fclose(fsav);
    }
  } /* Ende Ebenen laden */
  stop_wave(CN_ALL,0);
  if (game_erg!=1) {free_grafik(grf_maske);}
  fclose(fpeb);
  if (game_erg==1) {extro();}  /* geschafft */
  return(NULL);
} /* Ende game */


int menu(int flag) {
/* 1.Arg: 0=Hauptmenu, 1=Gamemenu
** Rueckgabe: 0=OK, 1=Quit (nur bei Hauptmenu)
*/
  const int x1=20,y1=10,x2=SC_WIDTH-40,y2=SC_HEIGHT-30;
  int cl[2],x0,y0,mnr,svg;
  char buf[512];
  cl[0]=color_index(CL_YELLOW,50);
  cl[1]=color_index(CL_YELLOW,100);
  svg=0;
  if (flag==0) {
    struct stat sbuf;
    CLEAR_BOX(NULL,RGB_BLACK);
    if (stat(INST_PFAD"/save/savegame",&sbuf)==0) {svg=1;}
  }
  mnr=1;
  while (1) {
    /* +++ Obermenu +++ */
    MENU_BILD(0,x1,y1,x2,y2,y0);
    x0=x1+40;
#if !defined(SPRACHE) || SPRACHE <= 1
    snprintf(buf,sizeof(buf),"Hilfe");  /* 1 */
    draw_text(NULL,cl[mnr==1?1:0],x0,y0,buf,strlen(buf),RGB_TRANS);
    y0+=8+5;
    snprintf(buf,sizeof(buf),"Lautstrke");  /* 2 */
    draw_text(NULL,cl[mnr==2?1:0],x0,y0,buf,strlen(buf),RGB_TRANS);
    y0+=8+5;
    snprintf(buf,sizeof(buf),"Spiel %s",flag==0?"starten (leicht)":"fortsetzen");  /* 3 */
    draw_text(NULL,cl[mnr==3?1:0],x0,y0,buf,strlen(buf),RGB_TRANS);
    y0+=8+5;
    if (flag==0) {
      snprintf(buf,sizeof(buf),"Spiel starten (schwer)");  /* 4 */
      draw_text(NULL,cl[mnr==4?1:0],x0,y0,buf,strlen(buf),RGB_TRANS);
      y0+=8+5;
      snprintf(buf,sizeof(buf),"letztes Spiel fortsetzen");  /* 5 */
      draw_text(NULL,cl[mnr==5?1:0],x0,y0,buf,strlen(buf),RGB_TRANS);
      y0+=8+5;
      y0+=10;
      snprintf(buf,sizeof(buf),"Ende");  /* 6 */
      draw_text(NULL,cl[mnr==6?1:0],x0,y0,buf,strlen(buf),RGB_TRANS);
      y0+=8+5;
    }
#elif SPRACHE == 2
    snprintf(buf,sizeof(buf),"Help");  /* 1 */
    draw_text(NULL,cl[mnr==1?1:0],x0,y0,buf,strlen(buf),RGB_TRANS);
    y0+=8+5;
    snprintf(buf,sizeof(buf),"Sound");  /* 2 */
    draw_text(NULL,cl[mnr==2?1:0],x0,y0,buf,strlen(buf),RGB_TRANS);
    y0+=8+5;
    snprintf(buf,sizeof(buf),"%s game",flag==0?"Start easy":"Continue");  /* 3 */
    draw_text(NULL,cl[mnr==3?1:0],x0,y0,buf,strlen(buf),RGB_TRANS);
    y0+=8+5;
    if (flag==0) {
      snprintf(buf,sizeof(buf),"Start hard game");  /* 4 */
      draw_text(NULL,cl[mnr==4?1:0],x0,y0,buf,strlen(buf),RGB_TRANS);
      y0+=8+5;
      snprintf(buf,sizeof(buf),"Continue last game");  /* 5 */
      draw_text(NULL,cl[mnr==5?1:0],x0,y0,buf,strlen(buf),RGB_TRANS);
      y0+=8+5;
      y0+=10;
      snprintf(buf,sizeof(buf),"Quit");  /* 6 */
      draw_text(NULL,cl[mnr==6?1:0],x0,y0,buf,strlen(buf),RGB_TRANS);
      y0+=8+5;
    }
#endif
    flush_window();
    /* Eingabe */
    setze_keys(1);
    while (1) {
      wait_time(50);
      get_keys();
      if (IS_KEYS(KEY_ENTER)) {break;}
      if ((IS_KEYS(KEY_UCURS)) || (IS_KEYS(KEY_KP_8))) {mnr--; break;}
      if ((IS_KEYS(KEY_DCURS)) || (IS_KEYS(KEY_KP_2))) {mnr++; break;}
    }
    if (mnr<1) {mnr=1;} else if (mnr>6) {mnr=6;}
    if ((flag>0) && (mnr==4)) {mnr=3;}
    if ((flag==0) && (mnr==5) && (svg==0)) {
      if ((IS_KEYS(KEY_UCURS)) || (IS_KEYS(KEY_KP_8))) {mnr--;}
      if ((IS_KEYS(KEY_DCURS)) || (IS_KEYS(KEY_KP_2))) {mnr++;}
      if (mnr==5) {mnr=6;}
    }
    if (IS_KEYS(KEY_ENTER)) {
      if (mnr==1) {menu_help(x1,y1,x2,y2,cl);}
      if (mnr==2) {menu_sound(x1,y1,x2,y2,cl,flag);}
      if (mnr==3) {
        if (flag==0) {gamelevel=1;}
        break;
      }
      if (mnr==4) {gamelevel=2; break;}
      if (mnr==5) {gamelevel=3; break;}
      if (mnr==6) {setze_keys(0); return(1);}
    }
  }
  setze_keys(0);
  return(0);
} /* Ende menu */


void menu_help(int x1,int y1,int x2,int y2,int cl[2]) {
#define HELP_TEXT \
    if ((y0+y00>=ym) && (y0+y00<=y2-22)) { \
      draw_text(NULL,cl[1],x0,y0+y00,buf,strlen(buf),RGB_TRANS); \
    } \
    y0+=8+3;
#define HELP_GRAF(P1,P2) \
    if ((y0+y00>=ym) && (y0+y00<=y2-12-(P2))) { \
      copy_grafik(NULL,x0,y0+y00,P1,0,0,0,0,RGB_TRANS); \
    } \
    y0+=P2+3;
#if !defined(SPRACHE) || SPRACHE <= 1
  static char wurm1[ES_ANZ][32]={
    "    Buschnatter             ",
    "    gelbe Ringelotter       ",
    "    grne Ringelotter       ",
    "    Nebelnatter             ",
    "    gemeine Grabviper       ",
    "    gescheckte Felsotter    ",
    "    schmale Nadelviper      "
  };
  static char wurm2[ES_ANZ][32]={
    "    leichte Beute, L: 5     ",
    "    recht problemlos, L: 6  ",
    "    recht problemlos, L: 6  ",
    "    schnell, agressiv, L: 7 ",
    "    ebenbrtig, L: 8        ",
    "    gefhrlich, stark, L: 9 ",
    "    Elite, L: 12            "
  };
#elif SPRACHE == 2
  static char wurm1[ES_ANZ][32]={
    "    bush adder              ",
    "    yellow wriggle snake    ",
    "    green wriggle snake     ",
    "    fog adder               ",
    "    common tomb viper       ",
    "    dappled rock snake      ",
    "    slim needle viper       "
  };
  static char wurm2[ES_ANZ][32]={
    "    easy booty, L: 5        ",
    "    nearly no problem, L: 6 ",
    "    nearly no problem, L: 6 ",
    "    quick and nasty, L: 7   ",
    "    as strong as you, L: 8  ",
    "    dangerous, strong, L: 9 ",
    "    elite, L: 12            "
  };
#endif
  const int miny00=-720;
  int x0,y0,y00,ym,ii,i1,i2;
  char buf[512];
  setze_keys(2);
  MENU_BILD(0,x1,y1,x2,y2,y0);
  ym=y0;
  x0=x1+18;
  y00=0;
  while (1) {
    ii=0;
    if (y00<0) {ii|=1;}
    if (y00>miny00) {ii|=2;}
    MENU_BILD(ii,x1,y1,x2,y2,y0);
#if !defined(SPRACHE) || SPRACHE <= 1
    strcpy(buf,"Bekmpfen Sie das Schlangen-"); HELP_TEXT;
    strcpy(buf,"gewrm und retten das       "); HELP_TEXT;
    strcpy(buf,"Mdchen, bevor es gefressen "); HELP_TEXT;
    strcpy(buf,"wird.                       "); HELP_TEXT;
    strcpy(buf,"                            "); HELP_TEXT;
    strcpy(buf,"Bewegen:       Cursortasten "); HELP_TEXT;
    strcpy(buf,"Gift spritzen: [STRG] links "); HELP_TEXT;
    strcpy(buf,"Menu:          [Return]     "); HELP_TEXT;
    strcpy(buf,"Pause:         [P]          "); HELP_TEXT;
    strcpy(buf,"Beenden:       [Q]          "); HELP_TEXT;
    strcpy(buf,"                            "); HELP_TEXT;
    strcpy(buf,"Wenn Sie eine Schlange      "); HELP_TEXT;
    strcpy(buf,"fressen, die lnger ist als "); HELP_TEXT;
    strcpy(buf,"Sie, verlieren Sie an Lnge."); HELP_TEXT;
    strcpy(buf,"Bsp: Sie haben die Lnge 6, "); HELP_TEXT;
    strcpy(buf,"     die gefressene Schlange"); HELP_TEXT;
    strcpy(buf,"     die Lnge 8 --> Sie    "); HELP_TEXT;
    strcpy(buf,"     verlieren 2, haben nun "); HELP_TEXT;
    strcpy(buf,"     also nur noch Lnge 4. "); HELP_TEXT;
    strcpy(buf,"Lngere Schlangen sind am   "); HELP_TEXT;
    strcpy(buf,"roten anstatt grnen Kopf   "); HELP_TEXT;
    strcpy(buf,"erkennbar.                  "); HELP_TEXT;
    strcpy(buf,"Nur der Kopf einer Schlange "); HELP_TEXT;
    strcpy(buf,"ist verwundbar.             "); HELP_TEXT;
    strcpy(buf,"                            "); HELP_TEXT;
    strcpy(buf,"Bei Treffern grner Gift-   "); HELP_TEXT;
    strcpy(buf,"spritzer velieren Sie Lnge "); HELP_TEXT;
    strcpy(buf,"1, bei rotem Gift Lnge 2.  "); HELP_TEXT;
    strcpy(buf,"                            "); HELP_TEXT;
    strcpy(buf,"Solange Sie eine Tarnkappe  "); HELP_TEXT;
    strcpy(buf,"benutzen, sind Sie sicher.  "); HELP_TEXT;
    strcpy(buf,"Giftflaschen erhhen Ihre   "); HELP_TEXT;
    strcpy(buf,"Lnge bis maximal zur       "); HELP_TEXT;
    strcpy(buf,"Ursprungslnge.             "); HELP_TEXT;
    strcpy(buf,"                            "); HELP_TEXT;
    strcpy(buf,"Die Leiste rechts gibt an,  "); HELP_TEXT;
    strcpy(buf," - Ihre Punktezahl          "); HELP_TEXT;
    strcpy(buf," - Ihre prozentuale Lnge   "); HELP_TEXT;
    strcpy(buf," - wieviel Gewrm noch kommt"); HELP_TEXT;
    strcpy(buf," - welches Gewrm gerade    "); HELP_TEXT;
    strcpy(buf,"   herumluft               "); HELP_TEXT;
    strcpy(buf,"                            "); HELP_TEXT;
    strcpy(buf,"                            "); HELP_TEXT;
    strcpy(buf,"Gewrm:                     "); HELP_TEXT;
    strcpy(buf,"-------                     "); HELP_TEXT;
    strcpy(buf,"                            "); HELP_TEXT;
#elif SPRACHE == 2
    strcpy(buf,"Kill enemy snakes and save  "); HELP_TEXT;
    strcpy(buf,"the girl before she is      "); HELP_TEXT;
    strcpy(buf,"eaten.                      "); HELP_TEXT;
    strcpy(buf,"                            "); HELP_TEXT;
    strcpy(buf,"Move:          cursor keys  "); HELP_TEXT;
    strcpy(buf,"Shoot poison:  [CTRL] left  "); HELP_TEXT;
    strcpy(buf,"Menu:          [Return]     "); HELP_TEXT;
    strcpy(buf,"Pause:         [P]          "); HELP_TEXT;
    strcpy(buf,"Quit:          [Q]          "); HELP_TEXT;
    strcpy(buf,"                            "); HELP_TEXT;
    strcpy(buf,"When you eat an enemy snake "); HELP_TEXT;
    strcpy(buf,"which is longer than you,   "); HELP_TEXT;
    strcpy(buf,"you become shorter.         "); HELP_TEXT;
    strcpy(buf,"F.e.: You have length 6,    "); HELP_TEXT;
    strcpy(buf,"      the eaten enemy snake "); HELP_TEXT;
    strcpy(buf,"      had length 8 --> you  "); HELP_TEXT;
    strcpy(buf,"      lose 2 of length, now "); HELP_TEXT;
    strcpy(buf,"      have still length 4.  "); HELP_TEXT;
    strcpy(buf,"Longer enemy snakes have a  "); HELP_TEXT;
    strcpy(buf,"red instead of a green head."); HELP_TEXT;
    strcpy(buf,"Only the head of a snake is "); HELP_TEXT;
    strcpy(buf,"vulnerable.                 "); HELP_TEXT;
    strcpy(buf,"                            "); HELP_TEXT;
    strcpy(buf,"When hit with green poison  "); HELP_TEXT;
    strcpy(buf,"shots you lose length 1,    "); HELP_TEXT;
    strcpy(buf,"when hit with red ones, you "); HELP_TEXT;
    strcpy(buf,"lose length 2.              "); HELP_TEXT;
    strcpy(buf,"                            "); HELP_TEXT;
    strcpy(buf,"While you use a camouflage  "); HELP_TEXT;
    strcpy(buf,"hat, you are save.          "); HELP_TEXT;
    strcpy(buf,"Poison bottles let you gain "); HELP_TEXT;
    strcpy(buf,"one more length until you   "); HELP_TEXT;
    strcpy(buf,"have your original length.  "); HELP_TEXT;
    strcpy(buf,"                            "); HELP_TEXT;
    strcpy(buf,"The right window lists:     "); HELP_TEXT;
    strcpy(buf," - your score               "); HELP_TEXT;
    strcpy(buf," - your length expressed as "); HELP_TEXT;
    strcpy(buf,"   a percentage             "); HELP_TEXT;
    strcpy(buf," - enemy snakes still coming"); HELP_TEXT;
    strcpy(buf," - enemy snakes just moving "); HELP_TEXT;
    strcpy(buf,"                            "); HELP_TEXT;
    strcpy(buf,"                            "); HELP_TEXT;
    strcpy(buf,"Enemy snakes:               "); HELP_TEXT;
    strcpy(buf,"-------------               "); HELP_TEXT;
    strcpy(buf,"                            "); HELP_TEXT;
#endif
    for (i1=0;i1<ES_ANZ;i1++) {
      i2=GRAFIK_HEIGHT(esymbol[i1]);
      y0+=i2/2-4;
      strcpy(buf,wurm1[i1]); HELP_TEXT; y0-=(8+3);
      y0-=(i2/2-4);
      HELP_GRAF(esymbol[i1],i2);
      strcpy(buf,wurm2[i1]); HELP_TEXT;
      y0+=7;
    }
    y0+=8*3;
    strcpy(buf,"          [Return]          "); HELP_TEXT;
    flush_window();
    /* Eingabe */
    while (1) {
      wait_time(70);
      get_keys();
      if ((IS_KEYS(KEY_ENTER)) || (IS_KEYS(KEY_Q))) {setze_keys(0); return;}
      if ((IS_KEYS(KEY_UCURS)) || (IS_KEYS(KEY_KP_8))) {
        if (y00<0) {y00+=4;}
        break;
      } 
      if ((IS_KEYS(KEY_DCURS)) || (IS_KEYS(KEY_KP_2))) {
        if (y00>miny00) {y00-=4;}
        break;
      } 
    }
  }
  setze_keys(0);
} /* Ende menu_help */


void menu_sound(int x1,int y1,int x2,int y2,int cl[2],int flag) {
  const char pvor[]="--------------------",pnach[]="++++++++++++++++++++";
  const int plen=15;
  int x0,y0,mnr;
  char buf[512];
  setze_keys(3);
  MENU_BILD(0,x1,y1,x2,y2,y0);
  mnr=1;
  if (flag==0) {play_wave(MUS_TEST,cnn[0],1,0);}
  play_wave(SND_TEST,cnn[1],1,0);
  while (1) {
    MENU_BILD(0,x1,y1,x2,y2,y0);
    x0=x1+20;
#if !defined(SPRACHE) || SPRACHE <= 1
    strcpy(buf,"         Lautstrke");
    draw_text(NULL,RGB_WHITE,x0,y0,buf,strlen(buf),RGB_TRANS);
    y0+=8+20;
    snprintf(buf,sizeof(buf),"%-10s|%.*sX%.*s|","Gesamt:",plen*vol_g/100,pvor,plen-plen*vol_g/100,pnach);
    draw_text(NULL,cl[mnr==1?1:0],x0,y0,buf,strlen(buf),RGB_TRANS);
    y0+=8+5;
    snprintf(buf,sizeof(buf),"%-10s|%.*sX%.*s|","Musik:",plen*vol_m/100,pvor,plen-plen*vol_m/100,pnach);
    draw_text(NULL,cl[mnr==2?1:0],x0,y0,buf,strlen(buf),RGB_TRANS);
    y0+=8+5;
    snprintf(buf,sizeof(buf),"%-10s|%.*sX%.*s|","Sound:",plen*vol_s/100,pvor,plen-plen*vol_s/100,pnach);
    draw_text(NULL,cl[mnr==3?1:0],x0,y0,buf,strlen(buf),RGB_TRANS);
    y0+=8+5;
    strcpy(buf,"Zurck");
    draw_text(NULL,cl[mnr==4?1:0],x0,y0,buf,strlen(buf),RGB_TRANS);
    y0+=8+5;
#elif SPRACHE == 2
    strcpy(buf,"           Volume");
    draw_text(NULL,RGB_WHITE,x0,y0,buf,strlen(buf),RGB_TRANS);
    y0+=8+20;
    snprintf(buf,sizeof(buf),"%-10s|%.*sX%.*s|","Main:",plen*vol_g/100,pvor,plen-plen*vol_g/100,pnach);
    draw_text(NULL,cl[mnr==1?1:0],x0,y0,buf,strlen(buf),RGB_TRANS);
    y0+=8+5;
    snprintf(buf,sizeof(buf),"%-10s|%.*sX%.*s|","Music:",plen*vol_m/100,pvor,plen-plen*vol_m/100,pnach);
    draw_text(NULL,cl[mnr==2?1:0],x0,y0,buf,strlen(buf),RGB_TRANS);
    y0+=8+5;
    snprintf(buf,sizeof(buf),"%-10s|%.*sX%.*s|","Sound:",plen*vol_s/100,pvor,plen-plen*vol_s/100,pnach);
    draw_text(NULL,cl[mnr==3?1:0],x0,y0,buf,strlen(buf),RGB_TRANS);
    y0+=8+5;
    strcpy(buf,"Back");
    draw_text(NULL,cl[mnr==4?1:0],x0,y0,buf,strlen(buf),RGB_TRANS);
    y0+=8+5;
#endif
    flush_window();
    /* Eingabe */
    while (1) {
      wait_time(50);
      get_keys();
      if ((mnr==4) && (IS_KEYS(KEY_ENTER))) {
        if (flag==0) {stop_wave(CN_ALL,0);} else {stop_wave(cnn[1],0);}
        setze_keys(0);
        return;
      }
      if ((IS_KEYS(KEY_UCURS)) || (IS_KEYS(KEY_KP_8))) {
        if (--mnr<1) {mnr=1;}
        break;
      }
      if ((IS_KEYS(KEY_DCURS)) || (IS_KEYS(KEY_KP_2))) {
        if (++mnr>4) {mnr=4;}
        break;
      }
      if ((IS_KEYS(KEY_LCURS)) || (IS_KEYS(KEY_KP_4))) {
        switch(mnr) {
          case 1: if (--vol_g>=0) {setze_sound(1);} else {vol_g=0;}
                  break;
          case 2: if (--vol_m>=0) {setze_sound(2);} else {vol_m=0;}
                  break;
          case 3: if (--vol_s>=0) {setze_sound(4);} else {vol_s=0;}
                  break;
        }
        break;
      }
      if ((IS_KEYS(KEY_RCURS)) || (IS_KEYS(KEY_KP_6))) {
        switch(mnr) {
          case 1: if (++vol_g<=100) {setze_sound(1);} else {vol_g=100;}
                  break;
          case 2: if (++vol_m<=100) {setze_sound(2);} else {vol_m=100;}
                  break;
          case 3: if (++vol_s<=100) {setze_sound(4);} else {vol_s=100;}
                  break;
        }
        break;
      }
    }
  }
  setze_keys(0);
} /* Ende menu_sound */


void zw_seq(int ebnr) {
  /* Zwischensequenz */
  const int boden=184;
  grafik * g_gang,* g_is[4],* g_schild;
  char buf[1024],* ptr;
  int i1,i2,mtt;
  if (ebnr>=10) {return;}
  if (ebnr==0) {
    snprintf(buf,sizeof(buf),"%s/film/gang2.vga",INST_PFAD);
  } else {
    snprintf(buf,sizeof(buf),"%s/film/gang3.vga",INST_PFAD);
  }
  if ((g_gang=load_grafik(buf))==NULL) {end_err("ZW-Seq","Load graphic");}
  snprintf(buf,sizeof(buf),"%s/film/schild.vga",INST_PFAD);
  if ((g_schild=load_grafik(buf))==NULL) {end_err("ZW-Seq","Load graphic");}
  for (i1=0;i1<4;i1++) {
    snprintf(buf,sizeof(buf),"%s/film/sq_is%d.vga",INST_PFAD,i1+1);
    if ((g_is[i1]=load_grafik(buf))==NULL) {end_err("ZW-Seq","Load graphic");}
  }

  mtt=SC_WIDTH/2-GRAFIK_WIDTH(g_is[0])*2/3;
  play_wave(SND_KRIECH,cnn[1],0,0);
  for (i2=0,i1=-GRAFIK_WIDTH(g_is[0]);i1<mtt;i1++) {
    copy_grafik(NULL,0,0,g_gang,0,0,0,0,RGB_FULL);
    copy_grafik(NULL,i1,boden-GRAFIK_HEIGHT(g_is[i2/7]),g_is[i2/7],0,0,0,0,RGB_TRANS);
    flush_window();
    wait_time(30);
    if (++i2==14) {i2=0;}
    get_keys();
    if ((IS_KEYS(KEY_Q)) || (IS_KEYS(KEY_ENTER)) || (IS_KEYS(KEY_SPACE))) {goto _ende_zw;}
  }
  if (ebnr>0) {
    stop_wave(cnn[1],0);
    copy_grafik(NULL,0,0,g_gang,0,0,0,0,RGB_FULL);
    copy_grafik(NULL,i1,boden-GRAFIK_HEIGHT(g_is[2]),g_is[2],0,0,0,0,RGB_TRANS);
    flush_window();
    sleep(2);
    get_keys();
    if ((IS_KEYS(KEY_Q)) || (IS_KEYS(KEY_ENTER)) || (IS_KEYS(KEY_SPACE))) {goto _ende_zw;}
    ptr=_zeige_schild(g_schild,ebnr);
    copy_grafik(NULL,0,0,g_gang,0,0,0,0,RGB_FULL);
    copy_grafik(NULL,i1,boden-GRAFIK_HEIGHT(g_is[3]),g_is[3],0,0,0,0,RGB_TRANS);
    i2=strlen(ptr);
    draw_text(NULL,color_index(CL_TURQUOISE,100),(SC_WIDTH-(i2*8))/2,140,ptr,i2,RGB_TRANS);
    flush_window();
    sleep(5);
    play_wave(SND_KRIECH,cnn[1],0,0);
  }
  for (i2=0;i1<SC_WIDTH;i1++) {
    copy_grafik(NULL,0,0,g_gang,0,0,0,0,RGB_FULL);
    copy_grafik(NULL,i1,boden-GRAFIK_HEIGHT(g_is[i2/7]),g_is[i2/7],0,0,0,0,RGB_TRANS);
    flush_window();
    wait_time(30);
    if (++i2==14) {i2=0;}
    get_keys();
    if ((IS_KEYS(KEY_Q)) || (IS_KEYS(KEY_ENTER)) || (IS_KEYS(KEY_SPACE))) {goto _ende_zw;}
  }
  sleep(2);

_ende_zw:
  stop_wave(cnn[1],0);
  free_grafik(g_gang);
  for (i1=0;i1<4;i1++) {free_grafik(g_is[i1]);}
  free_grafik(g_schild);
} /* Ende zw_seq */


void extro() {
  const int boden=184;
  film * flm1,* flm2,* flm3;
  film_bild bld;
  grafik * gr1,* gr2,* arrgh;
  char buf[1024];
  unsigned long l1;
  int i1,i2,i3,col1,col2;
  CLEAR_KEYS;
  ADD_KEYS(KEY_ENTER,SHORT_KEY);
  ADD_KEYS(KEY_Q,SHORT_KEY);
  ADD_KEYS(KEY_SPACE,SHORT_KEY);

  col1=color_index(CL_TURQUOISE,100);
  col2=color_index(CL_RED,100);
  snprintf(buf,sizeof(buf),"%s/film/e_arrgh.vga",INST_PFAD);
  if ((gr1=load_grafik(buf))==NULL) {end_err("Extro","Load graphic");}
  {int x,y,w,h;
   w=GRAFIK_WIDTH(gr1);
   h=GRAFIK_HEIGHT(gr1);
   if ((arrgh=create_grafik(w>h?w:h,h>w?h:w))==NULL) {end_err("Extro","Create graphic");}
   x=y=w=h=0;
   if (rotate_grafik(arrgh,gr1,30,&x,&y,&w,&h)==NULL) {end_err("Extro","Rotate graphic");}
   free_grafik(gr1);
  }
  vol_g+=5;
  if (vol_g>100) {vol_g=100;}
  setze_sound(1);

  /* +++ Extro-Film 1 erstellen +++ */

  if ((flm1=create_film(4))==NULL) {return;}
  SET_FILM(flm1,2,0,0,NULL);

  /* 1. Sequenz: Gang */
  snprintf(buf,sizeof(buf),"%s/film/gang4_1.vga",INST_PFAD);
  SET_FILM_BILD(&bld,load_grafik(buf),0,0,RGB_FULL,345,0,0,0);
  add_bild_to_film(flm1,&bld,1);
  snprintf(buf,sizeof(buf),"%s/film/gang4_2.vga",INST_PFAD);
  SET_FILM_BILD(&bld,load_grafik(buf),0,0,RGB_FULL,255+60,0,0,0);
  add_bild_to_film(flm1,&bld,1);
  snprintf(buf,sizeof(buf),"%s/film/gang4_3.vga",INST_PFAD);
  SET_FILM_BILD(&bld,load_grafik(buf),0,0,RGB_FULL,100,0,0,0);
  add_bild_to_film(flm1,&bld,1);

  /* 2. Sequenz: Maedchen */
  snprintf(buf,sizeof(buf),"%s/film/sq_md1.vga",INST_PFAD);
  gr1=load_grafik(buf);
  for (i1=0;i1<15;i1++) {
    SET_FILM_BILD(&bld,gr1,127,129,RGB_TRANS,15,0,0,0);
    add_bild_to_film(flm1,&bld,2);
    SET_FILM_BILD(&bld,gr1,131,129,RGB_TRANS,25,0,0,0);
    add_bild_to_film(flm1,&bld,2);
  }
  SET_FILM_BILD(&bld,gr1,129,129,RGB_TRANS,20,0,0,0);
  add_bild_to_film(flm1,&bld,2);
  SET_FILM_BILD(&bld,NULL,0,0,RGB_TRANS,300,0,0,0);
  add_bild_to_film(flm1,&bld,2);

  /* 3. Sequenz: eigene Schlange */
  snprintf(buf,sizeof(buf),"%s/film/sq_is1.vga",INST_PFAD);
  gr1=load_grafik(buf);
  snprintf(buf,sizeof(buf),"%s/film/sq_is2.vga",INST_PFAD);
  gr2=load_grafik(buf);
  SET_FILM_BILD(&bld,gr1,-GRAFIK_WIDTH(gr1),boden-GRAFIK_HEIGHT(gr1),RGB_TRANS,1,SND_KRIECH,cnn[1],0);
  add_bild_to_film(flm1,&bld,3);
  for (i1=1;i1<167;) {
    for (i2=0;i2<7;i2++) {
      SET_FILM_BILD(&bld,gr1,-GRAFIK_WIDTH(gr1)+i1++,boden-GRAFIK_HEIGHT(gr1),RGB_TRANS,1,0,0,0);
      add_bild_to_film(flm1,&bld,3);
    }
    for (i2=0;i2<7;i2++) {
      SET_FILM_BILD(&bld,gr2,-GRAFIK_WIDTH(gr2)+i1++,boden-GRAFIK_HEIGHT(gr1),RGB_TRANS,1,0,0,0);
      add_bild_to_film(flm1,&bld,3);
    }
  }
  snprintf(buf,sizeof(buf),"%s/film/sq_is3.vga",INST_PFAD);
  SET_FILM_BILD(&bld,load_grafik(buf),-GRAFIK_WIDTH(gr1)+i1,boden-GRAFIK_HEIGHT(gr1),RGB_TRANS,423,0,0,0);
  add_bild_to_film(flm1,&bld,3);
  snprintf(buf,sizeof(buf),"%s/film/sq_is7.vga",INST_PFAD);
  gr1=load_grafik(buf);
  SET_FILM_BILD(&bld,gr1,103,boden-GRAFIK_HEIGHT(gr1),RGB_TRANS,15,-1,cnn[1],0);
  add_bild_to_film(flm1,&bld,3);
  SET_FILM_BILD(&bld,gr1,131,boden-GRAFIK_HEIGHT(gr1),RGB_TRANS,15,0,0,0);
  add_bild_to_film(flm1,&bld,3);
  snprintf(buf,sizeof(buf),"%s/film/sq_is6.vga",INST_PFAD);
  gr1=load_grafik(buf);
  snprintf(buf,sizeof(buf),"%s/film/sq_is5.vga",INST_PFAD);
  gr2=load_grafik(buf);
  for (i1=160;i1>=0;) {
    for (i2=0;i2<4;i2++) {
      SET_FILM_BILD(&bld,gr1,-GRAFIK_WIDTH(gr1)+i1,boden-GRAFIK_HEIGHT(gr1),RGB_TRANS,1,0,0,0);
      add_bild_to_film(flm1,&bld,3);
      i1-=2;
    }
    for (i2=0;i2<4;i2++) {
      SET_FILM_BILD(&bld,gr2,-GRAFIK_WIDTH(gr2)+i1,boden-GRAFIK_HEIGHT(gr1),RGB_TRANS,1,0,0,0);
      add_bild_to_film(flm1,&bld,3);
      i1-=2;
    }
  }
  SET_FILM_BILD(&bld,NULL,0,0,RGB_TRANS,100,0,0,0);
  add_bild_to_film(flm1,&bld,3);

  /* 4. Sequenz: Texte */
  /* nichts */
  SET_FILM_BILD(&bld,NULL,0,0,RGB_TRANS,40,0,0,0);
  add_bild_to_film(flm1,&bld,4);
  /* Hilfe */
#if !defined(SPRACHE) || SPRACHE <= 1
  strcpy(buf,"Hilfe");
#elif SPRACHE == 2
  strcpy(buf,"Help");
#endif
  SET_FILM_BILD(&bld,text_to_grafik(col2,RGB_BLACK,0,0,buf),125,100,RGB_TRANS,40,0,0,0);
  add_bild_to_film(flm1,&bld,4);
  /* nichts */
  SET_FILM_BILD(&bld,NULL,0,0,RGB_TRANS,90,0,0,0);
  add_bild_to_film(flm1,&bld,4);
  /* Keine Angst... */
#if !defined(SPRACHE) || SPRACHE <= 1
  strcpy(buf,"Keine Angst\nIch befreie dich sofort");
#elif SPRACHE == 2
  strcpy(buf,"Don't be afraid\nI'll set you free");
#endif
  SET_FILM_BILD(&bld,text_to_grafik(col1,RGB_BLACK,2,1,buf),65,90,RGB_TRANS,70,0,0,0);
  add_bild_to_film(flm1,&bld,4);
  /* Bitte beeil dich... */
#if !defined(SPRACHE) || SPRACHE <= 1
  strcpy(buf,"Bitte beeil dich\nDer Vollmond kommt gleich");
#elif SPRACHE == 2
  strcpy(buf,"Please hurry up\nFull moon is coming now");
#endif
  SET_FILM_BILD(&bld,text_to_grafik(col2,RGB_BLACK,2,1,buf),60,90,RGB_TRANS,90,0,0,0);
  add_bild_to_film(flm1,&bld,4);
  /* nichts */
  SET_FILM_BILD(&bld,NULL,0,0,RGB_TRANS,20,0,0,0);
  add_bild_to_film(flm1,&bld,4);
  /* Zu spaet... */
#if !defined(SPRACHE) || SPRACHE <= 1
  strcpy(buf,"Zu spt!\nNun kommt das Scheusal ...");
#elif SPRACHE == 2
  strcpy(buf,"Too late!\nOhh, the monster is coming ...");
#endif
  SET_FILM_BILD(&bld,text_to_grafik(col2,RGB_BLACK,2,1,buf),60,90,RGB_TRANS,80,0,0,0);
  add_bild_to_film(flm1,&bld,4);
  /* Maerchen?... */
#if !defined(SPRACHE) || SPRACHE <= 1
  strcpy(buf,"Quetzalcoatl?\nGlaubst du an dieses Mrchen?");
#elif SPRACHE == 2
  strcpy(buf,"Quetzalcoatl?\nDo you believe to that fairy tale?");
#endif
  SET_FILM_BILD(&bld,text_to_grafik(col1,RGB_BLACK,2,1,buf),35,90,RGB_TRANS,90,0,0,0);
  add_bild_to_film(flm1,&bld,4);
  /* ARRGH... */
  if ((gr1=create_grafik(GRAFIK_WIDTH(arrgh),GRAFIK_HEIGHT(arrgh)))==NULL) {end_err("Extro","Create graphic");}
  copy_grafik(gr1,0,0,arrgh,0,0,0,0,RGB_FULL);
  SET_FILM_BILD(&bld,gr1,140,60,RGB_TRANS,40,SND_BRUELL,cnn[2],0);
  add_bild_to_film(flm1,&bld,4);
  /* Schnell!... */
#if !defined(SPRACHE) || SPRACHE <= 1
  strcpy(buf,"SCHNELL! STEIG AUF!");
#elif SPRACHE == 2
  strcpy(buf,"QUICKLY! GET UP ME!");
#endif
  SET_FILM_BILD(&bld,text_to_grafik(col1,RGB_BLACK,0,0,buf),80,100,RGB_TRANS,40,MUS_EXTRO,cnn[0],0);
  add_bild_to_film(flm1,&bld,4);
  /* nichts */
  SET_FILM_BILD(&bld,NULL,0,0,RGB_TRANS,70,0,0,0);
  add_bild_to_film(flm1,&bld,4);
  /* ARRGH... */
  if ((gr1=create_grafik(GRAFIK_WIDTH(arrgh),GRAFIK_HEIGHT(arrgh)))==NULL) {end_err("Extro","Create graphic");}
  copy_grafik(gr1,0,0,arrgh,0,0,0,0,RGB_FULL);
  SET_FILM_BILD(&bld,gr1,140,60,RGB_TRANS,40,SND_BRUELL,cnn[2],0);
  add_bild_to_film(flm1,&bld,4);
  /* nichts */
  SET_FILM_BILD(&bld,NULL,0,0,RGB_TRANS,100,0,0,0);
  add_bild_to_film(flm1,&bld,4);

  /* +++ Extro-Film 2 erstellen +++ */

  if ((flm2=create_film(4))==NULL) {return;}
  SET_FILM(flm2,3,0,0,NULL);

  /* 1. Sequenz: Gang */
  snprintf(buf,sizeof(buf),"%s/film/gang1.vga",INST_PFAD);
  gr1=load_grafik(buf);
  SET_FILM_BILD(&bld,gr1,0,0,RGB_FULL,90,0,0,0);
  add_bild_to_film(flm2,&bld,1);
  for (i2=0,i1=0;i1<25;i1++) {
    SET_FILM_BILD(&bld,gr1,0,-i2,RGB_FULL,5,0,0,0);
    add_bild_to_film(flm2,&bld,1);
    SET_FILM_BILD(&bld,gr1,0,i2,RGB_FULL,5,0,0,0);
    add_bild_to_film(flm2,&bld,1);
    i2=i1/6;
  }
  SET_FILM_BILD(&bld,NULL,0,0,RGB_TRANS,100,0,0,0);
  add_bild_to_film(flm2,&bld,1);

  /* 2. Sequenz: eigene Schlange */
  snprintf(buf,sizeof(buf),"%s/film/sq_is6.vga",INST_PFAD);
  gr1=load_grafik(buf);
  snprintf(buf,sizeof(buf),"%s/film/sq_is5.vga",INST_PFAD);
  gr2=load_grafik(buf);
  for (i1=320+GRAFIK_WIDTH(gr1);i1>=0;) {
    for (i2=0;i2<4;i2++) {
      SET_FILM_BILD(&bld,gr1,-GRAFIK_WIDTH(gr1)+i1,boden-GRAFIK_HEIGHT(gr1),RGB_TRANS,1,0,0,0);
      add_bild_to_film(flm2,&bld,2);
      i1-=2;
    }
    for (i2=0;i2<4;i2++) {
      SET_FILM_BILD(&bld,gr2,-GRAFIK_WIDTH(gr2)+i1,boden-GRAFIK_HEIGHT(gr1),RGB_TRANS,1,0,0,0);
      add_bild_to_film(flm2,&bld,2);
      i1-=2;
    }
  }
  SET_FILM_BILD(&bld,NULL,0,0,RGB_TRANS,200,0,0,0);
  add_bild_to_film(flm2,&bld,2);

  /* 3. Sequenz: Quetzalcoatl */
  snprintf(buf,sizeof(buf),"%s/film/sq_qs1.vga",INST_PFAD);
  gr1=load_grafik(buf);
  snprintf(buf,sizeof(buf),"%s/film/sq_qs2.vga",INST_PFAD);
  gr2=load_grafik(buf);
  for (i1=320+GRAFIK_WIDTH(gr1),i3=320;i3>=0;) {
    for (i2=0;i2<4;i2++) {
      SET_FILM_BILD(&bld,gr1,-GRAFIK_WIDTH(gr1)+i1+400,boden-GRAFIK_HEIGHT(gr1)-(i3-320)/100,RGB_TRANS,1,0,0,0);
      add_bild_to_film(flm2,&bld,3);
      i1-=3;
      i3--;
    }
    for (i2=0;i2<4;i2++) {
      SET_FILM_BILD(&bld,gr2,-GRAFIK_WIDTH(gr2)+i1+400,boden-GRAFIK_HEIGHT(gr1)+(i3-320)/100,RGB_TRANS,1,0,0,0);
      add_bild_to_film(flm2,&bld,3);
      i1-=3;
      i3--;
    }
  }
  SET_FILM_BILD(&bld,NULL,0,0,RGB_TRANS,100,0,0,0);
  add_bild_to_film(flm2,&bld,3);

  /* 4. Sequenz: ARRGH */
  /* nichts */
  SET_FILM_BILD(&bld,NULL,0,0,RGB_TRANS,110,0,0,0);
  add_bild_to_film(flm2,&bld,4);
  /* ARRGH... */
  if ((gr1=create_grafik(GRAFIK_WIDTH(arrgh),GRAFIK_HEIGHT(arrgh)))==NULL) {end_err("Extro","Create graphic");}
  copy_grafik(gr1,0,0,arrgh,0,0,0,0,RGB_FULL);
  SET_FILM_BILD(&bld,gr1,210,60,RGB_TRANS,40,SND_BRUELL,cnn[2],0);
  add_bild_to_film(flm2,&bld,4);
  /* nichts */
  SET_FILM_BILD(&bld,NULL,0,0,RGB_TRANS,200,0,0,0);
  add_bild_to_film(flm2,&bld,4);

  /* +++ Extro-Film 3 erstellen +++ */

  if ((flm3=create_film(5))==NULL) {return;}
  SET_FILM(flm3,3,0,0,NULL);

  /* 1. Sequenz: Gang */
  snprintf(buf,sizeof(buf),"%s/film/gang2.vga",INST_PFAD);
  gr1=load_grafik(buf);
  snprintf(buf,sizeof(buf),"%s/film/gang5.vga",INST_PFAD);
  gr2=load_grafik(buf);
  for (i2=3,i1=0;i1<19;i1++) {
    SET_FILM_BILD(&bld,gr1,0,-i2,RGB_FULL,5,0,0,0);
    add_bild_to_film(flm3,&bld,1);
    SET_FILM_BILD(&bld,gr1,0,i2,RGB_FULL,5,0,0,0);
    add_bild_to_film(flm3,&bld,1);
  }
  for (i2=5,i1=0;i1<8;i1++) {
    SET_FILM_BILD(&bld,gr1,-i2,0,RGB_FULL,2,0,0,0);
    add_bild_to_film(flm3,&bld,1);
    SET_FILM_BILD(&bld,gr1,i2,0,RGB_FULL,2,0,0,0);
    add_bild_to_film(flm3,&bld,1);
    i2=5-(i1/2);
  }
  SET_FILM_BILD(&bld,gr2,0,0,RGB_FULL,100,0,0,0);
  add_bild_to_film(flm3,&bld,1);

  /* 2. Sequenz: eigene Schlange */
  snprintf(buf,sizeof(buf),"%s/film/sq_is6.vga",INST_PFAD);
  gr1=load_grafik(buf);
  snprintf(buf,sizeof(buf),"%s/film/sq_is5.vga",INST_PFAD);
  gr2=load_grafik(buf);
  for (i1=320+GRAFIK_WIDTH(gr1);i1>=0;) {
    for (i2=0;i2<4;i2++) {
      SET_FILM_BILD(&bld,gr1,-GRAFIK_WIDTH(gr1)+i1,boden-GRAFIK_HEIGHT(gr1),RGB_TRANS,1,0,0,0);
      add_bild_to_film(flm3,&bld,2);
      i1-=2;
    }
    for (i2=0;i2<4;i2++) {
      SET_FILM_BILD(&bld,gr2,-GRAFIK_WIDTH(gr2)+i1,boden-GRAFIK_HEIGHT(gr1),RGB_TRANS,1,0,0,0);
      add_bild_to_film(flm3,&bld,2);
      i1-=2;
    }
  }
  SET_FILM_BILD(&bld,NULL,0,0,RGB_TRANS,200,0,0,0);
  add_bild_to_film(flm3,&bld,2);

  /* 3. Sequenz: Quetzalcoatl */
  snprintf(buf,sizeof(buf),"%s/film/sq_qs1.vga",INST_PFAD);
  gr1=load_grafik(buf);
  snprintf(buf,sizeof(buf),"%s/film/sq_qs2.vga",INST_PFAD);
  gr2=load_grafik(buf);
  for (i1=320+GRAFIK_WIDTH(gr1),i3=191;i3>=0;) {
    for (i2=0;i2<4;i2++) {
      SET_FILM_BILD(&bld,gr1,i1+80,boden-GRAFIK_HEIGHT(gr1)-(i3-320)/100,RGB_TRANS,1,0,0,0);
      add_bild_to_film(flm3,&bld,3);
      i1-=3;
      i3--;
    }
    for (i2=0;i2<4;i2++) {
      SET_FILM_BILD(&bld,gr2,i1+80,boden-GRAFIK_HEIGHT(gr1)+(i3-320)/100,RGB_TRANS,1,0,0,0);
      add_bild_to_film(flm3,&bld,3);
      i1-=3;
      i3--;
    }
  }
  SET_FILM_BILD(&bld,gr1,i1+80,boden-GRAFIK_HEIGHT(gr1),RGB_TRANS,1,SND_WAND,cnn[2],0);
  add_bild_to_film(flm3,&bld,3);
  for (i3=5,i2=0;i2<7;i2++) {
    SET_FILM_BILD(&bld,gr1,i1+80-i3,boden-GRAFIK_HEIGHT(gr1),RGB_TRANS,2,0,0,0);
    add_bild_to_film(flm3,&bld,3);
    SET_FILM_BILD(&bld,gr1,i1+80+i3,boden-GRAFIK_HEIGHT(gr1),RGB_TRANS,2,0,0,0);
    add_bild_to_film(flm3,&bld,3);
    i3=5-(i2/2);
  }
  SET_FILM_BILD(&bld,gr1,i1+80,boden-GRAFIK_HEIGHT(gr1),RGB_TRANS,5,0,0,0);
  add_bild_to_film(flm3,&bld,3);

  /* 4. Sequenz: Decke */
  SET_FILM_BILD(&bld,NULL,0,0,RGB_TRANS,220,0,0,0);
  add_bild_to_film(flm3,&bld,4);
  snprintf(buf,sizeof(buf),"%s/film/gangdecke.vga",INST_PFAD);
  gr1=load_grafik(buf);
  for (i1=30;i1<105;i1+=10) {
    SET_FILM_BILD(&bld,gr1,12,i1,RGB_FULL,1,0,0,0);
    add_bild_to_film(flm3,&bld,4);
  }
  SET_FILM_BILD(&bld,gr1,12,i1,RGB_FULL,50,0,0,0);
  add_bild_to_film(flm3,&bld,4);

  /* 5. Sequenz: ARRGH */
  /* nichts */
  SET_FILM_BILD(&bld,NULL,0,0,RGB_TRANS,200,0,0,0);
  add_bild_to_film(flm3,&bld,5);
  /* ARRGH... */
  if ((gr1=create_grafik(GRAFIK_WIDTH(arrgh),GRAFIK_HEIGHT(arrgh)))==NULL) {end_err("Extro","Create graphic");}
  copy_grafik(gr1,0,0,arrgh,0,0,0,0,RGB_FULL);
  SET_FILM_BILD(&bld,gr1,-5,60,RGB_TRANS,30,SND_BRUELL,cnn[2],0);
  add_bild_to_film(flm3,&bld,5);
  /* nichts */
  SET_FILM_BILD(&bld,NULL,0,0,RGB_TRANS,100,0,0,0);
  add_bild_to_film(flm3,&bld,5);

  /* +++ Extro-Film 1 zeigen +++ */
  reset_film(flm1,NULL,1);
  do {
    l1=copy_film(NULL,flm1,NULL);
    flush_window();
    wait_time(50);
  } while (l1<730L);

  /* +++ Extro-Film 2 zeigen +++ */
  reset_film(flm2,NULL,1);
  do {
    l1=copy_film(NULL,flm2,NULL);
    flush_window();
    wait_time(50);
  } while (l1<302L);

  /* +++ Extro-Film 3 zeigen +++ */
  reset_film(flm3,NULL,1);
  do {
    l1=copy_film(NULL,flm3,NULL);
    flush_window();
    wait_time(50);
  } while (l1<260L);

  /* +++ Ausklang +++ */
  for (i1=0;i1>=-63;i1--) {
    brightness(i1);
    flush_window();
    wait_time(40);
  }
  CLEAR_BOX(NULL,RGB_BLACK);
  flush_window();
  brightness(0);
  free_film(flm1);
  free_film(flm2);
  free_film(flm3);
  free_grafik(arrgh);
#if !defined(SPRACHE) || SPRACHE <= 1
  strcpy(buf,"Von Mai bis August 1851 verschwanden\nin Mexiko auf mysterise Weise\n3 Mdchen, von denen nur die letzte\nwohlbehalten zurckkehrte.\nIhre Geschichte klang dermaen\nunglaublich, da sie als Auswirkung\neines Schocks abgetan wurde.");
#elif SPRACHE == 2
  strcpy(buf,"From may to august 1851 three girls\ndisappeared in mexico in mysterious\nway, and only the last girl returned\nuninjured. Her story sounded so\nincredible that it was dismissed as\nan effect of a shock.");
#endif
  gr1=text_to_grafik(RGB_WHITE,RGB_BLACK,5,1,buf);
  copy_grafik(NULL,20,60,gr1,0,0,0,0,RGB_FULL);
  flush_window();
  free_grafik(gr1);
  sleep(8);
  stop_wave(cnn[0],5);
  sleep(4);
  for (i1=0;i1>=-63;i1--) {
    brightness(i1);
    flush_window();
    wait_time(70);
  }
  CLEAR_BOX(NULL,RGB_BLACK);
  flush_window();
  brightness(0);
  vol_g-=5;
  setze_sound(1);
} /* Ende extro */


void setze_keys(int flag) {
  CLEAR_KEYS;
  if (flag==0) {  /* Spieltasten */
    ADD_KEYS(KEY_LCTRL,LONG_KEY);   /* Giftschuss */
    ADD_KEYS(KEY_RCURS,LONG_KEY);   /* rechts kriechen */
    ADD_KEYS(KEY_LCURS,LONG_KEY);   /* links kriechen */
    ADD_KEYS(KEY_UCURS,LONG_KEY);   /* rauf kriechen */
    ADD_KEYS(KEY_DCURS,LONG_KEY);   /* runter kriechen */
    ADD_KEYS(KEY_KP_2,LONG_KEY);    /* runter kriechen */
    ADD_KEYS(KEY_KP_4,LONG_KEY);    /* links kriechen */
    ADD_KEYS(KEY_KP_6,LONG_KEY);    /* rechts kriechen */
    ADD_KEYS(KEY_KP_8,LONG_KEY);    /* rauf kriechen */
    ADD_KEYS(KEY_P,SHORT_KEY);      /* Pause */
    ADD_KEYS(KEY_Q,SHORT_KEY);      /* Quit */
    ADD_KEYS(KEY_ENTER,SHORT_KEY);  /* Menu */
    ADD_KEYS(KEY_SPACE,SHORT_KEY);
    ADD_KEYS(KEY_F2,SHORT_KEY);
  } else if (flag==1) {  /* OberMenu-Tasten */
    ADD_KEYS(KEY_RCURS,SHORT_KEY);
    ADD_KEYS(KEY_LCURS,SHORT_KEY);
    ADD_KEYS(KEY_UCURS,SHORT_KEY);
    ADD_KEYS(KEY_DCURS,SHORT_KEY);
    ADD_KEYS(KEY_KP_2,SHORT_KEY);
    ADD_KEYS(KEY_KP_4,SHORT_KEY);
    ADD_KEYS(KEY_KP_6,SHORT_KEY);
    ADD_KEYS(KEY_KP_8,SHORT_KEY);
    ADD_KEYS(KEY_ENTER,SHORT_KEY);
  } else if (flag==2) {  /* HilfeMenu-Tasten */
    ADD_KEYS(KEY_RCURS,LONG_KEY);
    ADD_KEYS(KEY_LCURS,LONG_KEY);
    ADD_KEYS(KEY_UCURS,LONG_KEY);
    ADD_KEYS(KEY_DCURS,LONG_KEY);
    ADD_KEYS(KEY_KP_2,LONG_KEY);
    ADD_KEYS(KEY_KP_4,LONG_KEY);
    ADD_KEYS(KEY_KP_6,LONG_KEY);
    ADD_KEYS(KEY_KP_8,LONG_KEY);
    ADD_KEYS(KEY_Q,SHORT_KEY);
    ADD_KEYS(KEY_ENTER,SHORT_KEY);
  } else if (flag==3) {  /* SoundMenu-Tasten */
    ADD_KEYS(KEY_RCURS,LONG_KEY);
    ADD_KEYS(KEY_LCURS,LONG_KEY);
    ADD_KEYS(KEY_UCURS,SHORT_KEY);
    ADD_KEYS(KEY_DCURS,SHORT_KEY);
    ADD_KEYS(KEY_KP_2,SHORT_KEY);
    ADD_KEYS(KEY_KP_4,LONG_KEY);
    ADD_KEYS(KEY_KP_6,LONG_KEY);
    ADD_KEYS(KEY_KP_8,SHORT_KEY);
    ADD_KEYS(KEY_ENTER,SHORT_KEY);
  }
} /* Ende setze_keys */


void setze_sound(int flag) {
  if (flag&1) {  /* Gesamtlautstaerke */
    set_vol(vol_g,0);
    set_vol(vol_g,1);
  }
  if (flag&2) {  /* Musiklautstaerke */
    volume_wave(cnn[0],vol_m/10);
  }
  if (flag&4) {  /* Soundlautstaerke */
    volume_wave(cnn[1]|cnn[2],vol_s/10);
  }
} /* Ende setze_sound */


void end_err(const char * prg,const char * msg) {
  set_vol(volm,0);
  set_vol(volp,1);
  end_sound();
  close_window();
  fprintf(stderr,"%s: %s: %s\n",prg,msg,errmsg);
  exit(1);
} /* Ende end_err */


char * _zeige_schild(grafik * grf,int ebn) {
  static char txt[128]="";
  int x,y,i1,col;
  col=color_index(CL_GREEN,100);
  CLEAR_BOX(NULL,RGB_BLACK);
  x=(SC_WIDTH-GRAFIK_WIDTH(grf))/2;
  y=(SC_HEIGHT-GRAFIK_HEIGHT(grf))/2;
  copy_grafik(NULL,x,y,grf,0,0,0,0,RGB_FULL);
  x+=20; y+=12;
#if !defined(SPRACHE) || SPRACHE <= 1
  if (ebn==1) {
    draw_text(NULL,col,x,y+=10,"  Willkommen im Tempel   ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"    von Quetzalcoatl!    ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"                         ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Freiwillige Opfer weisen ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"wir nicht zurck - gehen ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Sie bitte an der nchsten",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Kreuzung rechts.         ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"                         ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Aber du mit der komischen",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Nase, kehre sofort um!   ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Ohne herumzuschnffeln!  ",25,RGB_TRANS);
    strcpy(txt,"Was ist denn mit meiner Nase?");
  } else if (ebn==2) {
    draw_text(NULL,col,x,y+=10,"Sie betreten nun die Loge",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"der geheimen Wissenschaft",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"                         ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Bitte Fe abputzen.     ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"                         ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Und du blauer Junge,     ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"haben wir dir nicht      ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"gesagt, du sollst        ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"verschwinden? Dies ist   ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"die letzte Warnung!      ",25,RGB_TRANS);
    strcpy(txt,"Die haben was gegen mich.");
  } else if (ebn==3) {
    draw_text(NULL,col,x,y+=10,"Interne Mitteilung:      ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Heute ist ein schner    ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Vollmond angesagt. Bitte ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"zur Opferung des Mdchens",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"alle erscheinen.         ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"                         ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Pa auf Schnffler!      ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Wir werden nun ernstlich ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"bse. Diese Nacht wird   ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"deine letzte sein!       ",25,RGB_TRANS);
    strcpy(txt,"Da kann man ja Angst bekommen");
  } else if (ebn==4) {
    draw_text(NULL,col,x,y+=10,"Sie betreten nun die Loge",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"der angeheiterten Weisen ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"                         ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Das ist nicht zum Lachen!",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"                         ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Schnffler, du bist uns  ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"lstig. In dieser Loge   ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"wirst du dein armseliges ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Leben beenden.           ",25,RGB_TRANS);
    strcpy(txt,"Tatschlich? Na, weiter gehts.");
  } else if (ebn==5) {
    draw_text(NULL,col,x,y+=10,"Wer hat meinen Rbensaft ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"gesehen? Bitte abzugeben ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"bei Tworf.               ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"                         ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Wir verabschieden uns von",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"dem blauen Schnffler.   ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Er hat uns eine Weile    ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"lang begleitet und       ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"gedenkt nun abzutreten.  ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Wir werden ihm ein       ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"unehrenvolles Grab geben.",25,RGB_TRANS);
    strcpy(txt,"Bisher haben nur die ins Gras gebissen");
  } else if (ebn==6) {
    draw_text(NULL,col,x,y+=10,"Sie betreten nun die Loge",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"der obersten Herrfhrer  ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"                         ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Anmeldung erforderlich!  ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"                         ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Schnffler, du bist gut. ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Wir aber sind besser und ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"schicken dir nun unsere  ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Elite. Wir sind nicht    ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"gewillt, dein Wten      ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"weiter zuzulassen.       ",25,RGB_TRANS);
    strcpy(txt,"Langsam wachen die wohl auf.");
  } else if (ebn==7) {
    draw_text(NULL,col,x,y+=10,"Aufruf an alle:          ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Oberpriester Graf Rhynz  ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"gewhrt demjenigen, der  ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"den blauen Schnffler zur",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Strecke bringt, einen    ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Monat lang die doppelte  ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Ration an Nachtisch.     ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"                         ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Damit bist du erledigt!  ",25,RGB_TRANS);
    strcpy(txt,"Jetzt kriegen die das Muffensausen!");
  } else if (ebn==8) {
    draw_text(NULL,col,x,y+=10,"Sie betreten nun die Loge",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"der Priesterkaste        ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"                         ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Eintritt verboten!       ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"                         ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Schnffler, du wirst das ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Mdchen nicht mehr       ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"befreien knnen, denn der",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Vollmond ist nahe.       ",25,RGB_TRANS);
    strcpy(txt,"Vielleicht sollte ich mich etwas eilen");
  } else if (ebn==9) {
    draw_text(NULL,col,x,y+=10,"Snippl fragt Thyn-Foorn, ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"wo er den magischen Stein",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"vergraben hat?           ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"                         ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Nun ist es zu spt, du   ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Schnffler, das Mdchen  ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"wurde soeben mit Aufgang ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"des Vollmondes geopfert. ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Jetzt kommen wir selbst  ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"und machen dich fertig.  ",25,RGB_TRANS);
    strcpy(txt,"Das ist doch nur ein Bluff...");
  }
#elif SPRACHE == 2
  if (ebn==1) {
    draw_text(NULL,col,x,y+=10,"   Welcome to temple     ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"    of Quetzalcoatl!     ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"                         ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Voluntary victims please ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"go next crossing to the  ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"right.                   ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"                         ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"But you with you silly   ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"nose, turn back          ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"immediatelly without     ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"snooping!                ",25,RGB_TRANS);
    strcpy(txt,"What is with my nose?");
  } else if (ebn==2) {
    draw_text(NULL,col,x,y+=10,"You're entering the lodge",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"of secret science        ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"                         ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Please clean your shoes. ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"                         ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"And you blue boy, did'nt ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"we tell you to disappear?",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"This is our last warning!",25,RGB_TRANS);
    strcpy(txt,"They have something against me.");
  } else if (ebn==3) {
    draw_text(NULL,col,x,y+=10,"Internal message:        ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Tonight a wonderfull     ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"full moon is predicted.  ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"All have to come when the",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"girl is sacrificed.      ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"                         ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Pay attention, snooper!  ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"We are now really angry. ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"This night will be your  ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"last night!              ",25,RGB_TRANS);
    strcpy(txt,"Whouu! I could get fear.");
  } else if (ebn==4) {
    draw_text(NULL,col,x,y+=10,"You're entering the lodge",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"of the tipsy wise snakes ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"                         ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"That's not ridiculous!   ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"                         ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Snooper, you are becoming",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"tiresome. In this lodge  ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"you will finish your poor",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"life.                    ",25,RGB_TRANS);
    strcpy(txt,"Really? We will see.");
  } else if (ebn==5) {
    draw_text(NULL,col,x,y+=10,"Who has found my carrot  ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"juice? Please give it to ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Tworf.                   ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"                         ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"We say goodbye to the    ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"blue snopper, which has  ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"escorted us a little time",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"and wants to die now.    ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"We will give him an      ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"inhonourable grave.      ",25,RGB_TRANS);
    strcpy(txt,"Till now only they've visited the grave");
  } else if (ebn==6) {
    draw_text(NULL,col,x,y+=10,"You're entering the lodge",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"of topmost army leaders  ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"                         ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Announcement needed!     ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"                         ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Snooper, you are good.   ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"But we are even better   ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"and send you now our     ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"elite. We are not willed ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"to permit longer your    ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"raging.                  ",25,RGB_TRANS);
    strcpy(txt,"Now the slowly are waking up.");
  } else if (ebn==7) {
    draw_text(NULL,col,x,y+=10,"Call for all snakes:     ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Temple priest count Rhynz",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"provides a double ration ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"of dessert for one month ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"for them, who kills the  ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"blue snooper.            ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"                         ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Now you are dead!        ",25,RGB_TRANS);
    strcpy(txt,"I think, they begin to feel funny!");
  } else if (ebn==8) {
    draw_text(NULL,col,x,y+=10,"You're entering the lodge",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"of temple priests        ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"                         ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Entry forbidden!         ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"                         ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Snooper, you won't be    ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"able to set free the girl",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"because full moon is near",25,RGB_TRANS);
    strcpy(txt,"Perhaps i should hurry a bit?");
  } else if (ebn==9) {
    draw_text(NULL,col,x,y+=10,"Snippl asks Thyn-Foorn,  ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"where he has buried the  ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"magical stone?           ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"                         ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"Now it is too late, you  ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"snooper, the girl just   ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"has been slaughtered with",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"rise of full moon.       ",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"And now weself are coming",25,RGB_TRANS);
    draw_text(NULL,col,x,y+=10,"to finish your life.     ",25,RGB_TRANS);
    strcpy(txt,"They want to bluff me ...");
  }
#endif
  flush_window();
  for (i1=0;i1<180;i1++) {
    wait_time(100);
    get_keys();
    if ((IS_KEYS(KEY_Q)) || (IS_KEYS(KEY_ENTER)) || (IS_KEYS(KEY_SPACE))) {break;}
  }
  return(txt);
} /* Ende _zeige_schild */


void _intro_film(film * flm,void * vptr,int flag) {
  if (flag==0) {
    if (flm->step==1L) {
      flm->aktiv[3]=FILM_ACT_DEAD;
      flm->aktiv[7]=FILM_ACT_DEAD;
    } else if (flm->step==100L) {
      flm->aktiv[3]=FILM_ACT_OK;
      flm->aktiv[7]=FILM_ACT_OK;
    }
    if (flm->bildnr[7]==4) {
      if (flm->bild[7][4]->count==1) {
        flm->aktiv[2]=FILM_ACT_SLEEP;
        flm->bildnr[2]=2;
        flm->bild[2][2]->count=flm->bild[2][2]->count_to-1;
        flm->aktiv[3]=FILM_ACT_DEAD;
      } else if (flm->bild[7][4]->count==150) {
        flm->aktiv[2]=FILM_ACT_OK;
        flm->aktiv[3]=FILM_ACT_OK;
      }
    } else if (flm->bildnr[7]==6) {
      if (flm->bild[7][6]->count==80) {
        flm->aktiv[3]=FILM_ACT_DEAD;
      }
    }
  } else {memset(flm->aktiv,FILM_ACT_OK,sizeof(flm->aktiv));}
} /* Ende _intro_film */
