/* Zufallszahl von 0 bis Z-1 */
#define ZUFALL(Z)  ((int)((float)(Z)*rand()/(RAND_MAX+1.0)))


/* +++ Structs +++ */

#define MAXIMAL_GLIED 15  /* maximale Gliedanzahl fuer alle */
#define GIFT_GESCHWPROZ 400  /* Prozentzahl Giftschuss von Schlangengeschw. */
#define GIFT_PIXELMAX 400  /* max. Pixelgeschw.*100 Giftschuss */

typedef struct {  /* eigene Schlange */
#define IS_XYPLUS 100  /* Geschwindigkeit der Schlange: Zahl/100 */
#define IS_GIFT_MAX 1  /* Anzahl Giftschuesse gleichzeitig */
  int glied_max,glied_mom;  /* Gliedanzahl: hoechste und aktuelle */
  int x,y,z;  /* x,y Position Kopf, Ausrichung (Wert 0=rechts) */
  int xyz_pos[MAXIMAL_GLIED];  /* Gliedpositionen */
  int xdez,ydez;  /* 1/100-Dezimalstelle von X-Zahl, Y-Zahl */
  int gift_taste;  /* ob neu gedrueckt (=0) oder gehalten (>0) */
  int tarnkappe;  /* Tarnkappe aktiv: 0=nein, >0=Anzahl Runden noch */
  struct {  /* Giftschuesse */
    int aktiv;  /* 0=inaktiv, >0=aktiv */
    grafik * grg;
    int x,y,w,h;
    int xplus,xdez;  /* X-Zahl/100 pro Runde zu addieren, 1/100-Dezimalstelle */
    int yplus,ydez;  /* Y-Zahl/100 pro Runde zu addieren, 1/100-Dezimalstelle */
  } gift[IS_GIFT_MAX];
} my_snake;

typedef struct {  /* Feind-Schlange */
#define EN_GIFT_MAX 3  /* max. Anzahl Giftschuesse pro Feindschlange */
  int aktiv;  /* 0=tot, 1=aktiv, 2=in Wartestellung */
  int gattung;  /* Index fuer enemy_art */
  int glied_mom;  /* Gliedanzahl: aktuelle */
  int x,y,z;  /* x,y Position Kopf, Ausrichung (Wert 0=rechts) */
  int xyz_pos[MAXIMAL_GLIED];  /* Gliedpositionen */
  int xplus,xdez;  /* X-Zahl/100 pro Runde zu addieren, 1/100-Dezimalstelle */
  int yplus,ydez;  /* Y-Zahl/100 pro Runde zu addieren, 1/100-Dezimalstelle */
  int xynoch;  /* wann naechste Richtungsaenderung */
  int gzhl;  /* Zaehler fuer naechsten Giftschuss */
  int tarnkappe;  /* Tarnkappe aktiv: 0=nein, >0=Anzahl Runden noch */
  struct {  /* Giftschuesse */
    int aktiv;  /* 0=inaktiv, >0=aktiv */
    grafik * grg[2];
    int x,y,w,h,zhl;
    int xplus,xdez;  /* X-Zahl/100 pro Runde zu addieren, 1/100-Dezimalstelle */
    int yplus,ydez;  /* Y-Zahl/100 pro Runde zu addieren, 1/100-Dezimalstelle */
  } gift[EN_GIFT_MAX];
} enemy_snake;

typedef struct {  /* Ebene */
#define EB_EN_MAX 99  /* max. Anzahl Feindschlangen pro Ebene */
  union {
    grafik * hoehle;
    int i[2];
  } u;
  int hell;  /* Helligkeit (-63/62) */
  int freib,mauer;  /* Freibildnummer, Grenzbildnummer */
  int musnr;  /* Musiknummer (m<nr>.mid) */
  int en_anz;  /* Anzahl Feindschlangen aktiv */
  int en_max,en_mom;  /* Gesamtanzahl Feindschlangen, naechste die kommt */
  int gattung[EB_EN_MAX];  /* Gattung jeder Feindschlange */
  int warte_max[EB_EN_MAX];  /* Rundenanzahl bevor naechste Schlange kommt */
  int giftfl_weg,giftfl_da,giftfl_zhl;  /* Giftflasche: wie lange weg, da; Zaehler */
  int tarnkp_weg,tarnkp_da,tarnkp_zhl;  /* Tarnkappe: wie lange weg, da; Zaehler */
  int giftfl_max,tarnkp_max;  /* wie oft erscheinen */
} ebene;

struct {  /* Extras */
  int aktiv;
  int x,y;
  int graf_runde;  /* Zaehler fuer Grafikdarstellung */
  grafik * bild[2];
} giftfl,tarnkp;

#define ES_ANZ 7
struct {  /* Feind-Schlangen-Gattungen */
  int glied_max;  /* Gliedanzahl: hoechste */
  int gift_anz;  /* Anzahl Giftschuesse */
  int gift_stark;  /* Giftstaerke jedes Giftschusses: 1 oder 2 */
  int xyplus;  /* Geschwindigkeit der Schlange: Zahl/100 */
  grafik * glied[4];  /* Glied */
} enemy_art[ES_ANZ]={
  /* +++ Definitionen der Feind-Schlangen-Gattungen +++ */
  {  /* Buschnatter */
    5,
    1,
    1,
    50,
    {NULL,NULL,NULL,NULL}
  },
  {  /* gelbe Ringelotter */
    6,
    2,
    1,
    65,
    {NULL,NULL,NULL,NULL}
  },
  {  /* gruene Ringelotter */
    6,
    2,
    1,
    65,
    {NULL,NULL,NULL,NULL}
  },
  {  /* Nebelnatter */
    7,
    3,
    1,
    150,
    {NULL,NULL,NULL,NULL}
  },
  {  /* gemeine Grabviper */
    8,
    2,
    1,
    80,
    {NULL,NULL,NULL,NULL}
  },
  {  /* gescheckte Felsotter */
    9,
    1,
    2,
    100,
    {NULL,NULL,NULL,NULL}
  },
  {  /* schmale Nadelviper */
    12,
    2,
    2,
    120,
    {NULL,NULL,NULL,NULL}
  }
};
