#ifndef _SOUND_VOLUME_SETTINGS_H_
#define _SOUND_VOLUME_SETTINGS_H_

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>

int sound_volume_settings(const char *,int);

int sound_volume_settings(const char * savefile,int sndnr) {
/* load saved sound volume or have it set and save it
** (init_sound() must have been called)
** 1.arg: filename to save settings
** 2.arg: wave number of loaded sound file ready to play
**        (must have been loaded with load_wave())
** return value: sound setting value (0 to 100)
*/
  const char pvor[]="-------------------------------",pnach[]="+++++++++++++++++++++++++++++++";
  const int plen=30;
  int volg,i0,i1;
  char buf[128];
  FILE * ffp;

  if ((savefile!=NULL) && ((ffp=fopen(savefile,"r"))!=NULL)) {
    if (fscanf(ffp,"%d",&volg)==1) {fclose(ffp); return(volg);}
    fclose(ffp);
  }
  i0=set_vol(-1,0);
  i1=set_vol(-1,1);
  volg=(i0+i1)/2;
  if (volg<0) {return(0);}
  CLEAR_KEYS;
  ADD_KEYS(KEY_RCURS,LONG_KEY);
  ADD_KEYS(KEY_LCURS,LONG_KEY);
  ADD_KEYS(KEY_KP_4,LONG_KEY);
  ADD_KEYS(KEY_KP_6,LONG_KEY);
  ADD_KEYS(KEY_ENTER,SHORT_KEY);
  play_wave(sndnr,CN_ALL,1,0);
  set_font(NULL,0,0);

  while (1) {
    CLEAR_BOX(NULL,RGB_BLACK);
    draw_text(NULL,RGB_WHITE,(SC_WIDTH-20*8)/2,30,"Please adjust volume",20,RGB_FULL);
    snprintf(buf,sizeof(buf),"|%.*sX%.*s|",plen*volg/100,pvor,plen-plen*volg/100,pnach);
    i0=strlen(buf);
    draw_text(NULL,RGB_WHITE,(SC_WIDTH-i0*8)/2,60,buf,i0,RGB_FULL);
    draw_text(NULL,RGB_WHITE,(SC_WIDTH-i0*8)/2,110,"[<-] and [->]: set volume",25,RGB_FULL);
    draw_text(NULL,RGB_WHITE,(SC_WIDTH-i0*8)/2,122,"[RETURN]:      OK",17,RGB_FULL);
    flush_window();
    /* Eingabe */
    while (1) {
      wait_time(50);
      get_keys();
      if (IS_KEYS(KEY_ENTER)) {break;}
      if ((IS_KEYS(KEY_LCURS)) || (IS_KEYS(KEY_KP_4))) {
        if (--volg>=0) {
          set_vol(volg,0);
          set_vol(volg,1);
        } else {volg=0;}
        break;
      }
      if ((IS_KEYS(KEY_RCURS)) || (IS_KEYS(KEY_KP_6))) {
        if (++volg<=100) {
          set_vol(volg,0);
          set_vol(volg,1);
        } else {volg=100;}
        break;
      }
    }
    if (IS_KEYS(KEY_ENTER)) {break;}
  }

  stop_wave(CN_ALL,0);
  CLEAR_BOX(NULL,RGB_BLACK);
  flush_window();
  CLEAR_KEYS;
  if ((savefile!=NULL) && ((ffp=fopen(savefile,"w"))!=NULL)) {
    fprintf(ffp,"%d\n",volg);
    fchmod(fileno(ffp),0666);
    fclose(ffp);
  }
  return(volg);
} /* Ende sound_volume_settings */

#endif /* _SOUND_VOLUME_SETTINGS_H_ */
